#include<stdio.h>
#include<stdlib.h>
#include<math.h>

int main(int iArgc, char** cArg){

  FILE *fOutput, *fInput;
  char cNameOut[255], cNameInput[255], cLabel[30];
  int  iI, iJ, iImax, iJmax;
  int iMaxFrom3(int,int,int);
  double eOrigo,eZmax,eV1Y, eV1X, eV2Y, eV2X;
  double eAlpha, eBeta;
  double **eStat;
  double eMax, eZstep, eStep, eTemp, eFontsc;
  double eMinFrom2(double,double);

  if(iArgc >= 2){
    sscanf(cArg[1],"%s",cNameInput);
  }
  else{
    sscanf("StatM5N5XX30.txt","%s",cNameInput);
  }
  fInput = fopen(cNameInput,"r");

  if(iArgc >= 3){
    sscanf(cArg[2],"%s",cNameOut);
  }
  else{
    sscanf("default.ps","%s",cNameOut);
  }
  fOutput = fopen(cNameOut,"w");

  /* Reading alpha */

  if(iArgc >= 4){
    sscanf(cArg[3],"%lf",&eAlpha);
  }
  else{
    eAlpha = 40.0;
  }
  if(eAlpha < 10.0){
    eAlpha = 10.0;
  }
  if(eAlpha > 80.0){
    eAlpha = 80.0;
  }
  eAlpha *= 3.1415/180.0;

  /* Reading beta */

  if(iArgc >= 5){
    sscanf(cArg[4],"%lf",&eBeta);
  }
  else{
    eBeta = 45.0;
  }
  if(eBeta < 20.0){
    eBeta = 20.0;
  }
  if(eBeta > 80.0){
    eBeta = 80.0;
  }
  eBeta *= 3.1415/180.0;

  /* Reading input */
  fscanf(fInput,"%d",&iImax);
  fscanf(fInput,"%d",&iJmax);
  eStat = (double**) malloc(sizeof(double*)*iMaxFrom3(iImax,iJmax,8));
  for(iI = 0; iI < iMaxFrom3(iImax,iJmax,8); iI++){
    eStat[iI] = (double*) malloc(sizeof(double)*iMaxFrom3(iImax,iJmax,8));
  }

  for(iI = 0; iI < iMaxFrom3(iImax,iJmax,8); iI++){
    for(iJ = 0; iJ < iMaxFrom3(iImax,iJmax,8); iJ++){
      eStat[iI][iJ] = 0.0;
    }
  }

  eMax = 0.0;
  for(iI = 0; iI < iImax; iI++){
    for(iJ = 0; iJ < iJmax; iJ++){
      fscanf(fInput,"%lf",&eStat[iI][iJ]);
      if(eMax < eStat[iI][iJ]){
	eMax = eStat[iI][iJ];
      }
    }
  }
  fclose(fInput);

  /* scaling */
  eOrigo = 7500.0 * (cos(eAlpha) * sin(eBeta) + cos(eBeta))/(cos(eAlpha) * sin(eBeta) + cos(eBeta) + sin(eAlpha) * sin(eBeta));
  eZmax = -7000.0 * cos(eBeta)/(cos(eAlpha) * sin(eBeta) + cos(eBeta) + sin(eAlpha) * sin(eBeta));

  eV1Y = 7500.0 * sin(eAlpha) * sin(eBeta)/((cos(eAlpha) * sin(eBeta) + cos(eBeta) + sin(eAlpha) * sin(eBeta)) * iMaxFrom3(iImax,iJmax,8));
  eV1X = 9500.0 * cos(eAlpha)/((cos(eAlpha) + sin(eAlpha)) * iMaxFrom3(iImax,iJmax,8));

  eV2Y = -7500.0 * cos(eAlpha) * sin(eBeta)/((cos(eAlpha) * sin(eBeta) + cos(eBeta) + sin(eAlpha) * sin(eBeta)) * iMaxFrom3(iImax,iJmax,8));
  eV2X = 9500.0 * sin(eAlpha)/((cos(eAlpha) + sin(eAlpha)) * iMaxFrom3(iImax,iJmax,8));

  eFontsc = 6000.0/(double)(iMaxFrom3(iImax,iJmax,8));
  /*  sscanf(cInput[1],"%d",&iJ);*/
  /*  fprintf(fOutput,"%d %d\n", iI,iJ);*/
  fprintf(fOutput,"%%!PS-Adobe-2.0\n");
  fprintf(fOutput,"%%%%Title: proba.ps\n");
  fprintf(fOutput,"%%%%Creator: Istvan Miklos\n");
  fprintf(fOutput,"%%%%Orientation: Landscape\n");
  fprintf(fOutput,"%%%%Pages: 1\n");
  fprintf(fOutput,"%%%%BoundingBox: 0 0 612 792\n");
  fprintf(fOutput,"%%%%BeginSetup\n");
  fprintf(fOutput,"%%%%IncludeFeature: *PageSize Letter\n");
  fprintf(fOutput,"%%%%EndSetup\n");
  fprintf(fOutput,"%%%%Magnification: 1.0000\n");
  fprintf(fOutput,"%%%%EndComments\n");
  fprintf(fOutput,"/$F2psDict 200 dict def\n");
  fprintf(fOutput,"$F2psDict begin\n");
  fprintf(fOutput,"$F2psDict /mtrx matrix put\n");
  fprintf(fOutput,"/col-1 {0 setgray} bind def\n");
  fprintf(fOutput,"/col0 {0.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col1 {0.300 0.400 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col2 {0.100 0.200 0.900 srgb} bind def\n");
  fprintf(fOutput,"/col3 {0.050 0.100 0.800 srgb} bind def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"end\n");
  fprintf(fOutput,"save\n");
  fprintf(fOutput,"newpath 0 792 moveto 0 0 lineto 612 0 lineto 612 792 lineto closepath clip newpath\n");
  fprintf(fOutput,"65.2 63.5 translate\n");
  fprintf(fOutput," 90 rotate\n");
  fprintf(fOutput,"1 -1 scale\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"/cp {closepath} bind def\n");
  fprintf(fOutput,"/ef {eofill} bind def\n");
  fprintf(fOutput,"/gr {grestore} bind def\n");
  fprintf(fOutput,"/gs {gsave} bind def\n");
  fprintf(fOutput,"/sa {save} bind def\n");
  fprintf(fOutput,"/rs {restore} bind def\n");
  fprintf(fOutput,"/l {lineto} bind def\n");
  fprintf(fOutput,"/m {moveto} bind def\n");
  fprintf(fOutput,"/rm {rmoveto} bind def\n");
  fprintf(fOutput,"/n {newpath} bind def\n");
  fprintf(fOutput,"/s {stroke} bind def\n");
  fprintf(fOutput,"/sh {show} bind def\n");
  fprintf(fOutput,"/slc {setlinecap} bind def\n");
  fprintf(fOutput,"/slj {setlinejoin} bind def\n");
  fprintf(fOutput,"/slw {setlinewidth} bind def\n");
  fprintf(fOutput,"/srgb {setrgbcolor} bind def\n");
  fprintf(fOutput,"/rot {rotate} bind def\n");
  fprintf(fOutput,"/sc {scale} bind def\n");
  fprintf(fOutput,"/sd {setdash} bind def\n");
  fprintf(fOutput,"/ff {findfont} bind def\n");
  fprintf(fOutput,"/sf {setfont} bind def\n");
  fprintf(fOutput,"/scf {scalefont} bind def\n");
  fprintf(fOutput,"/sw {stringwidth} bind def\n");
  fprintf(fOutput,"/tr {translate} bind def\n");
  fprintf(fOutput,"/tnt {dup dup currentrgbcolor\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}\n");
  fprintf(fOutput,"  bind def\n");
  fprintf(fOutput,"/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul\n");
  fprintf(fOutput,"  4 -2 roll mul srgb} bind def\n");
  fprintf(fOutput,"/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n");
  fprintf(fOutput,"/$F2psEnd {$F2psEnteredState restore end} def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"$F2psBegin\n");
  fprintf(fOutput,"10 setmiterlimit\n");
  fprintf(fOutput," 0.06000 0.06000 sc\n");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /* Z axis */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,(int)eOrigo,
	  700,(int)(eOrigo+eZmax*1.1));
  fprintf(fOutput,"1.00 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  750,(int)(eOrigo+eZmax*1.1),
	  650,(int)(eOrigo+eZmax*1.1),
	  700,(int)(eOrigo+eZmax*1.1-125));



  /* labeling Z axis */
  fprintf(fOutput,"17.500 slw\n");
  if(eMax < -0.05*eZmax/7000.0){
    eStep = 0.001;
  }
  else if(eMax < -0.5*eZmax/7000.0){
    eStep = 0.01;
  }
  else{
    eStep = 0.1;
  }


  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eMinFrom2(-1.5*eZmax*eStep/eMax,400.0));
  /*  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);*/
  eZstep = 0.0;
  while(eZstep < eMax*1.1){
    if(eMax < -0.05*eZmax/7000.0){    
      fprintf(fOutput,"%d %d m gs 1 -1 sc (%.3f) col0 sh gr\n",
	      600-(int)(2.8*eMinFrom2(-1.5*eZmax*eStep/eMax,400.0)),
	      (int)(eOrigo+((eZstep-eMinFrom2(0.3*eStep,-120*eMax/eZmax))*eZmax/eMax)),
	      eZstep);
    }
    else if(eMax < -0.5*eZmax/7000.0){
      fprintf(fOutput,"%d %d m gs 1 -1 sc (%.2f) col0 sh gr\n",
	      600-(int)(2.1*eMinFrom2(-1.5*eZmax*eStep/eMax,400.0)),
	      (int)(eOrigo+((eZstep-eMinFrom2(0.3*eStep,-120*eMax/eZmax))*eZmax/eMax)),
	      eZstep);
    }
    else{
      fprintf(fOutput,"%d %d m gs 1 -1 sc (%.1f) col0 sh gr\n",
	      600-(int)(1.4*eMinFrom2(-1.5*eZmax*eStep/eMax,400.0)),
	      (int)(eOrigo+((eZstep-eMinFrom2(0.3*eStep,-120*eMax/eZmax))*eZmax/eMax)),
	      eZstep);
    }
    fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	    600,
	    (int)(eOrigo+(eZstep*eZmax/eMax)),
	    700,
	    (int)(eOrigo+(eZstep*eZmax/eMax)));
    if(eMax < -0.05*eZmax/7000.0){
      eZstep += 0.002;
    }
    else if(eMax < -0.5*eZmax/7000.0){
      eZstep += 0.02;
    }
    else{
      eZstep += 0.1;
    }
  }
  /* X axis */

  eTemp = 1.0/sqrt(eV1X * eV1X + eV1Y * eV1Y);
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eMinFrom2(1/eTemp,400));
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,(int)eOrigo,
	  700+(int)(eV1X*(iMaxFrom3(iImax,iJmax,8)+2)),(int)(eOrigo+(eV1Y*(iMaxFrom3(iImax,iJmax,8)+2))));
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  700+(int)(eV1X*(iMaxFrom3(iImax,iJmax,8)+2)),
	  (int)(eOrigo+(eV1Y*(iMaxFrom3(iImax,iJmax,8)+2))),
	  700+(int)(eV1X*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV1X *eTemp - 50.0 * eV1Y * eTemp),
	  (int)(eOrigo+(eV1Y*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV1Y * eTemp + 50.0 * eV1X * eTemp)),
	  700+(int)(eV1X*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV1X * eTemp + 50.0 * eV1Y * eTemp),
	  (int)(eOrigo+(eV1Y*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV1Y * eTemp - 50.0 * eV1X *eTemp)));
  
  for(iI = 0; iI < iMaxFrom3(iImax,iJmax,8); iI++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%d) col0 sh gr\n",
	    700 + (int)((iI+0.5) * eV1X - 1.2*eMinFrom2(1/eTemp,400) * eV1Y * eTemp),
	    (int)(eOrigo + (iI+0.5) * eV1Y +  1.2*eMinFrom2(1/eTemp,400)* eV1X *eTemp),
	    iI);
  }

  /*  Labeling  */
  
  sprintf(cLabel,"%s","Inversions");
  for(iI = 0; iI < 10; iI++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%c) col0 sh gr\n",
	    700 + (int)((iI+2) * eV1X * iMaxFrom3(iImax,iJmax,8)/12.0 - 2.2*eMinFrom2(1/eTemp,400) * eV1Y  * eTemp),
	    (int)(eOrigo + (iI+2) * eV1Y * iMaxFrom3(iImax,iJmax,8)/12.0 + 2.2*eMinFrom2(1/eTemp,400) * eV1X *eTemp),
	    cLabel[iI]);
  }

  /* Y axis */

  eTemp = 1.0/sqrt(eV2X * eV2X + eV2Y * eV2Y);
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eMinFrom2(1/eTemp,400));
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,(int)eOrigo,
	  700+(int)(eV2X*(iMaxFrom3(iImax,iJmax,8)+2)),(int)(eOrigo+(eV2Y*(iMaxFrom3(iImax,iJmax,8)+2))));
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  700+(int)(eV2X*(iMaxFrom3(iImax,iJmax,8)+2)),
	  (int)(eOrigo+(eV2Y*(iMaxFrom3(iImax,iJmax,8)+2))),
	  700+(int)(eV2X*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV2X *eTemp - 50.0 * eV2Y * eTemp),
	  (int)(eOrigo+(eV2Y*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV2Y * eTemp + 50.0 * eV2X * eTemp)),
	  700+(int)(eV2X*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV2X * eTemp + 50.0 * eV2Y * eTemp),
	  (int)(eOrigo+(eV2Y*(iMaxFrom3(iImax,iJmax,8)+2) - 150.0 * eV2Y * eTemp - 50.0 * eV2X *eTemp)));
  
  for(iJ = 0; iJ < iMaxFrom3(iImax,iJmax,8); iJ++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%d) col0 sh gr\n",
	    700 + (int)((iJ+0.5) * eV2X - 1.2*eMinFrom2(1/eTemp,400) * eV2Y * eTemp + eV1X * iMaxFrom3(iImax,iJmax,8)),
	    (int)(eOrigo + (iJ+0.5) * eV2Y + 1.2*eMinFrom2(1/eTemp,400) * eV2X *eTemp + eV1Y * iMaxFrom3(iImax,iJmax,8)),
	    iJ);


  }
  /*  Labeling  */
  
  sprintf(cLabel,"%s","Transpositions");
  for(iJ = 0; iJ < 14; iJ++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%c) col0 sh gr\n",
	    700 + (int)((iJ+3) * eV2X * iMaxFrom3(iImax,iJmax,8)/16 - 2.2*eMinFrom2(1/eTemp,400) * eV2Y * eTemp + eV1X * iMaxFrom3(iImax,iJmax,8)),
	    (int)(eOrigo + (iJ+3) * eV2Y * iMaxFrom3(iImax,iJmax,8)/16 + 2.2*eMinFrom2(1/eTemp,400) * eV2X *eTemp  + eV1Y * iMaxFrom3(iImax,iJmax,8)),
	    cLabel[iJ]);
  }

  /* Data */
  fprintf(fOutput,"1.000 slw\n");
   for(iI = 0; iI < iMaxFrom3(iImax,iJmax,8); iI++){
    for(iJ = iMaxFrom3(iImax,iJmax,8)-1; iJ >=0; iJ--){
      /* eleje */
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col3 1.00 shd ef gr gs col0 s gr\n",
	      700 + (int)(eV1X * iI + eV2X * iJ),
	      (int)(eOrigo + eV1Y * iI + eV2Y * iJ),
	      700 + (int)(eV1X * (iI + 1) + eV2X * iJ),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * iJ),
	      700 + (int)(eV1X * (iI + 1) + eV2X * iJ),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * iJ + eStat[iI][iJ] * eZmax/eMax),
	      700 + (int)(eV1X * iI + eV2X * iJ),
	      (int)(eOrigo + eV1Y * iI + eV2Y * iJ + eStat[iI][iJ] * eZmax/eMax));
      /* oldala */
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col2 1.00 shd ef gr gs col0 s gr\n",
	      700 + (int)(eV1X * (iI + 1) + eV2X * iJ),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * iJ),
	      700 + (int)(eV1X * (iI + 1) + eV2X * (iJ + 1)),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * (iJ + 1)),
	      700 + (int)(eV1X * (iI + 1) + eV2X * (iJ + 1)),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * (iJ + 1) + eStat[iI][iJ] * eZmax/eMax),
	      700 + (int)(eV1X * (iI + 1) + eV2X * iJ),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * iJ + eStat[iI][iJ] * eZmax/eMax));	      

      /* teteje */
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col1 1.00 shd ef gr gs col0 s gr\n",
	      700 + (int)(eV1X * iI + eV2X * iJ),
	      (int)(eOrigo + eV1Y * iI + eV2Y * iJ + eStat[iI][iJ] * eZmax/eMax),
	      700 + (int)(eV1X * (iI + 1) + eV2X * iJ),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * iJ + eStat[iI][iJ] * eZmax/eMax),
	      700 + (int)(eV1X * (iI + 1) + eV2X * (iJ + 1)),
	      (int)(eOrigo + eV1Y * (iI + 1) + eV2Y * (iJ + 1) + eStat[iI][iJ] * eZmax/eMax),
	      700 + (int)(eV1X * iI + eV2X * (iJ + 1)),
	      (int)(eOrigo + eV1Y * iI + eV2Y * (iJ + 1) + eStat[iI][iJ] * eZmax/eMax));


    }
   } 
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/

  /* at the end */
  fprintf(fOutput,"$F2psEnd\n");
  fprintf(fOutput,"rs\n");
  fprintf(fOutput,"showpage\n");

  for(iI = 0; iI < iImax; iI++){
    free(eStat[iI]);
  }
  free(eStat);

  return(0);
}

int iMaxFrom3(int iI,
	      int iJ,
	      int iK){

  int iR;

  iR = iI>iJ?iI:iJ;
  iR = iR>iK?iR:iK;
  
  return(iR);
}

double eMinFrom2(double eX,
		 double eY){

  return(eX<eY?eX:eY);

}
