#include<stdio.h>
#include<math.h>
#include <stdlib.h>

int main(int iArgc, char** cArg){

  FILE *fOutput, *fInput;
  char cNameOut[255], cNameInput[255];
  int  iI, iJ, iImax;
  double *eStatBefore, *eStatAfter;
  char **cName;
  double eMax, eFontsc;
  int iMax, iZstep;
  char cTemp[30];

  if(iArgc >= 2){
    sscanf(cArg[1],"%s",cNameInput);
  }
  else{
    sscanf("1.breakpoint","%s",cNameInput);
  }
  fInput = fopen(cNameInput,"r");
  
  if(iArgc >= 3){
    sscanf(cArg[2],"%s",cNameOut);
  }
  else{
    sscanf("default.ps","%s",cNameOut);
  }
  fOutput = fopen(cNameOut,"w");
 
  /* Reading input */
  fscanf(fInput,"%d\n",&iImax);
  eStatBefore = (double*) malloc(sizeof(double)*iImax);
  eStatAfter = (double*) malloc(sizeof(double)*iImax);
  cName = (char**) malloc(sizeof(char*)*iImax);
  for(iI = 0; iI < iImax; iI++){
    cName[iI] = (char*) malloc(sizeof(char)*30);
  }
  /*  printf("memory allocated!\n");*/

  eMax = 0.0;
  for(iI = 0; iI < iImax; iI++){
    fscanf(fInput,"%s",cName[iI]);
    fscanf(fInput,"%lf",&eStatBefore[iI]);
    if(eMax < eStatBefore[iI]){
      eMax = eStatBefore[iI];
    }
    fscanf(fInput,"%lf",&eStatAfter[iI]);
    if(eMax < eStatAfter[iI]){
      eMax = eStatAfter[iI];
    }
  }
  eFontsc = 200.0;

  fclose(fInput);

  fprintf(fOutput,"%d %d\n", iI,iJ);
  fprintf(fOutput,"%%!PS-Adobe-2.0\n");
  fprintf(fOutput,"%%%%Title: proba.ps\n");
  fprintf(fOutput,"%%%%Creator: Istvan Miklos\n");
  fprintf(fOutput,"%%%%Orientation: Landscape\n");
  fprintf(fOutput,"%%%%Pages: 1\n");
  fprintf(fOutput,"%%%%BoundingBox: 0 0 612 792\n");
  fprintf(fOutput,"%%%%BeginSetup\n");
  fprintf(fOutput,"%%%%IncludeFeature: *PageSize Letter\n");
  fprintf(fOutput,"%%%%EndSetup\n");
  fprintf(fOutput,"%%%%Magnification: 1.0000\n");
  fprintf(fOutput,"%%%%EndComments\n");
  fprintf(fOutput,"/$F2psDict 200 dict def\n");
  fprintf(fOutput,"$F2psDict begin\n");
  fprintf(fOutput,"$F2psDict /mtrx matrix put\n");
  fprintf(fOutput,"/col-1 {0 setgray} bind def\n");
  fprintf(fOutput,"/col0 {0.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col1 {1.000 0.300 0.200 srgb} bind def\n");
  fprintf(fOutput,"/col2 {0.200 1.000 0.200 srgb} bind def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"end\n");
  fprintf(fOutput,"save\n");
  fprintf(fOutput,"newpath 0 792 moveto 0 0 lineto 612 0 lineto 612 792 lineto closepath clip newpath\n");
  fprintf(fOutput,"65.2 63.5 translate\n");
  fprintf(fOutput," 90 rotate\n");
  fprintf(fOutput,"1 -1 scale\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"/cp {closepath} bind def\n");
  fprintf(fOutput,"/ef {eofill} bind def\n");
  fprintf(fOutput,"/gr {grestore} bind def\n");
  fprintf(fOutput,"/gs {gsave} bind def\n");
  fprintf(fOutput,"/sa {save} bind def\n");
  fprintf(fOutput,"/rs {restore} bind def\n");
  fprintf(fOutput,"/l {lineto} bind def\n");
  fprintf(fOutput,"/m {moveto} bind def\n");
  fprintf(fOutput,"/rm {rmoveto} bind def\n");
  fprintf(fOutput,"/n {newpath} bind def\n");
  fprintf(fOutput,"/s {stroke} bind def\n");
  fprintf(fOutput,"/sh {show} bind def\n");
  fprintf(fOutput,"/slc {setlinecap} bind def\n");
  fprintf(fOutput,"/slj {setlinejoin} bind def\n");
  fprintf(fOutput,"/slw {setlinewidth} bind def\n");
  fprintf(fOutput,"/srgb {setrgbcolor} bind def\n");
  fprintf(fOutput,"/rot {rotate} bind def\n");
  fprintf(fOutput,"/sc {scale} bind def\n");
  fprintf(fOutput,"/sd {setdash} bind def\n");
  fprintf(fOutput,"/ff {findfont} bind def\n");
  fprintf(fOutput,"/sf {setfont} bind def\n");
  fprintf(fOutput,"/scf {scalefont} bind def\n");
  fprintf(fOutput,"/sw {stringwidth} bind def\n");
  fprintf(fOutput,"/tr {translate} bind def\n");
  fprintf(fOutput,"/tnt {dup dup currentrgbcolor\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}\n");
  fprintf(fOutput,"  bind def\n");
  fprintf(fOutput,"/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul\n");
  fprintf(fOutput,"  4 -2 roll mul srgb} bind def\n");
  fprintf(fOutput,"/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n");
  fprintf(fOutput,"/$F2psEnd {$F2psEnteredState restore end} def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"$F2psBegin\n");
  fprintf(fOutput,"10 setmiterlimit\n");
  fprintf(fOutput," 0.06000 0.06000 sc\n");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /* Z axis 1*/
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  700,150);
  fprintf(fOutput,"1.00 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  750,150,
	  650,150,
	  700,0);


  /* labeling Z axis 1 */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);
  
  iMax = (int)(eMax*12.0);
  /*  printf("iMaxInv: %d\n",iMaxInv);*/

  iZstep = 0;
  while(iZstep < iMax){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%.2f) col0 sh gr\n",
	    700-(int)(sqrt(eFontsc)*sprintf(cTemp,"%.2f",(double)iZstep/10.0)*10),
	    (int)(7050.0-iZstep*7000.0/((double)(iMax))),
	    (double)iZstep/10.0);
    fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	    650,(int)(7000.0-iZstep*7000.0/((double)(iMax))),
	    700,(int)(7000.0-iZstep*7000.0/((double)(iMax))));
    
    if(iMax > 5000){
      iZstep += 1000;
    }
    else if(iMax > 500){
      iZstep += 100;
    }
    else if(iMax > 50){
      iZstep += 10;
    }
    else{
      iZstep+=2;
    }
  }


  /* X axis 1*/

  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  10700,7000);
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  10850,7000,
	  10700,6950,
	  10700,7050);
  
  /* printf("iBegin: %d\n",iBegin);*/
  for(iI = 0; iI < iImax; iI++){
    fprintf(fOutput,"n %d %d m %d %d l gs col1 s gr \n",
	    700+(int)((iI + 0.3) * 10000.0/(double)iImax), 
	    7000,
	    700+(int)((iI + 0.5) * 10000.0/(double)iImax), 
	    7000 + (int)(sqrt(eFontsc)*16.0));
    fprintf(fOutput,"n %d %d m %d %d l gs col2 s gr \n",
	    700+(int)((iI + 0.7) * 10000.0/(double)iImax), 
	    7000,
	    700+(int)((iI + 0.5) * 10000.0/(double)iImax), 
	    7000 + (int)(sqrt(eFontsc)*16.0));
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	    700+(int)((iI + 0.3) * 10000.0/(double)iImax), 
	    7000 + (int)(sqrt(eFontsc)*32.0),
	    cName[iI]);
  }


  /* Data */
  /*  printf("iMin: %d, iMax: %d\n",iMin, iMax);
      printf("eMin: %e, eMax: %e\n",eMin, eMax);*/
  fprintf(fOutput,"1.000 slw\n");
  if(iMax > 0){
    for(iI = 0; iI < iImax; iI++){
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col1 1.00 shd ef gr gs col0 s gr\n",
	      700+(int)((iI + 0.15) * 10000.0/(iImax)),
	      7000,
	      700+(int)((iI + 0.15) * 10000.0/(iImax)),
	      (int)(7000.0-eStatBefore[iI]*70000.0/(double)iMax),
	      700+(int)((iI + 0.45) * 10000.0/(iImax)),
	      (int)(7000.0-eStatBefore[iI]*70000.0/(double)iMax),
	      700+(int)((iI + 0.45) * 10000.0/(iImax)),
	      7000);
      
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col2 1.00 shd ef gr gs col0 s gr\n",
	      700+(int)((iI + 0.55) * 10000.0/(iImax)),
	      7000,
	      700+(int)((iI + 0.55) * 10000.0/(iImax)),
	      (int)(7000.0-eStatAfter[iI]*70000.0/(double)iMax),
	      700+(int)((iI + 0.85) * 10000.0/(iImax)),
	      (int)(7000.0-eStatAfter[iI]*70000.0/(double)iMax),
	      700+(int)((iI + 0.85) * 10000.0/(iImax)),
	      7000);      
    } 
  }
  fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col1 1.00 shd ef gr gs col0 s gr\n",
	  9000,
	  0,
	  9500,
	  0,
	  9500,
	  200,
	  9000,
	  200);
  fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	  9700,
	  200,
	  "Before");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col2 1.00 shd ef gr gs col0 s gr\n",
	  9000,
	  500,
	  9500,
	  500,
	  9500,
	  700,
	  9000,
	  700);
  fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	  9700,
	  700,
	  "After");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/

  /* at the end */
  fprintf(fOutput,"$F2psEnd\n");
  fprintf(fOutput,"rs\n");
  fprintf(fOutput,"showpage\n");

  free(eStatBefore);
  free(eStatAfter);
  for(iI = 0; iI < iImax; iI++){
    free(cName[iI]);
  }
  free(cName);

  return(0);
}
