#include<stdio.h>
#include<math.h>
#include <stdlib.h>

int main(int iArgc, char** cArg){

  FILE *fOutput, *fInput;
  char cNameOut[255], cNameInput[255];
  int  iI, iJ, iImax;
  double *eStatInv, *eStatTrans;
  double eMaxInv, eMaxTrans, eFontsc;
  int iMaxInv, iMaxTrans, iZstep;
  char cTemp[30];

  if(iArgc >= 2){
    sscanf(cArg[1],"%s",cNameInput);
  }
  else{
    sscanf("likelihood.txt","%s",cNameInput);
  }
  fInput = fopen(cNameInput,"r");
  
  if(iArgc >= 3){
    sscanf(cArg[2],"%s",cNameOut);
  }
  else{
    sscanf("default.ps","%s",cNameOut);
  }
  fOutput = fopen(cNameOut,"w");
 
  /* Reading input */
  fscanf(fInput,"%d\n",&iImax);
  eStatInv = (double*) malloc(sizeof(double)*iImax);
  eStatTrans = (double*) malloc(sizeof(double)*iImax);
  /*  printf("memory allocated!\n");*/

  fscanf(fInput,"%s",cTemp);
  eMaxInv = 0.0;
  for(iI = 0; iI < iImax; iI++){
    fscanf(fInput,"%lf",&eStatInv[iI]);
    /*    printf("eStatInv: %f\n",eStatInv[iI]);*/
    if(eMaxInv < eStatInv[iI]){
      eMaxInv = eStatInv[iI];
    }
  }
  /*  printf("eMaxInd: %f\n",eMaxInv);*/
  fscanf(fInput,"%s",cTemp);
  eMaxTrans = 0.0;
  for(iI = 0; iI < iImax; iI++){
    fscanf(fInput,"%lf",&eStatTrans[iI]);
    /*    printf("eStatTrans: %f\n",eStatTrans[iI]);*/
    if(eMaxTrans < eStatTrans[iI]){
      eMaxTrans = eStatTrans[iI];
    }
  }
  /*  printf("eMaxTrans: %f\n",eMaxTrans);*/
  /*  printf("read!\n");*/

  eFontsc = 200.0;


  fclose(fInput);

  fprintf(fOutput,"%d %d\n", iI,iJ);
  fprintf(fOutput,"%%!PS-Adobe-2.0\n");
  fprintf(fOutput,"%%%%Title: proba.ps\n");
  fprintf(fOutput,"%%%%Creator: Istvan Miklos\n");
  fprintf(fOutput,"%%%%Orientation: Landscape\n");
  fprintf(fOutput,"%%%%Pages: 1\n");
  fprintf(fOutput,"%%%%BoundingBox: 0 0 612 792\n");
  fprintf(fOutput,"%%%%BeginSetup\n");
  fprintf(fOutput,"%%%%IncludeFeature: *PageSize Letter\n");
  fprintf(fOutput,"%%%%EndSetup\n");
  fprintf(fOutput,"%%%%Magnification: 1.0000\n");
  fprintf(fOutput,"%%%%EndComments\n");
  fprintf(fOutput,"/$F2psDict 200 dict def\n");
  fprintf(fOutput,"$F2psDict begin\n");
  fprintf(fOutput,"$F2psDict /mtrx matrix put\n");
  fprintf(fOutput,"/col-1 {0 setgray} bind def\n");
  fprintf(fOutput,"/col0 {0.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col1 {0.050 0.100 0.800 srgb} bind def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"end\n");
  fprintf(fOutput,"save\n");
  fprintf(fOutput,"newpath 0 792 moveto 0 0 lineto 612 0 lineto 612 792 lineto closepath clip newpath\n");
  fprintf(fOutput,"65.2 63.5 translate\n");
  fprintf(fOutput," 90 rotate\n");
  fprintf(fOutput,"1 -1 scale\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"/cp {closepath} bind def\n");
  fprintf(fOutput,"/ef {eofill} bind def\n");
  fprintf(fOutput,"/gr {grestore} bind def\n");
  fprintf(fOutput,"/gs {gsave} bind def\n");
  fprintf(fOutput,"/sa {save} bind def\n");
  fprintf(fOutput,"/rs {restore} bind def\n");
  fprintf(fOutput,"/l {lineto} bind def\n");
  fprintf(fOutput,"/m {moveto} bind def\n");
  fprintf(fOutput,"/rm {rmoveto} bind def\n");
  fprintf(fOutput,"/n {newpath} bind def\n");
  fprintf(fOutput,"/s {stroke} bind def\n");
  fprintf(fOutput,"/sh {show} bind def\n");
  fprintf(fOutput,"/slc {setlinecap} bind def\n");
  fprintf(fOutput,"/slj {setlinejoin} bind def\n");
  fprintf(fOutput,"/slw {setlinewidth} bind def\n");
  fprintf(fOutput,"/srgb {setrgbcolor} bind def\n");
  fprintf(fOutput,"/rot {rotate} bind def\n");
  fprintf(fOutput,"/sc {scale} bind def\n");
  fprintf(fOutput,"/sd {setdash} bind def\n");
  fprintf(fOutput,"/ff {findfont} bind def\n");
  fprintf(fOutput,"/sf {setfont} bind def\n");
  fprintf(fOutput,"/scf {scalefont} bind def\n");
  fprintf(fOutput,"/sw {stringwidth} bind def\n");
  fprintf(fOutput,"/tr {translate} bind def\n");
  fprintf(fOutput,"/tnt {dup dup currentrgbcolor\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}\n");
  fprintf(fOutput,"  bind def\n");
  fprintf(fOutput,"/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul\n");
  fprintf(fOutput,"  4 -2 roll mul srgb} bind def\n");
  fprintf(fOutput,"/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n");
  fprintf(fOutput,"/$F2psEnd {$F2psEnteredState restore end} def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"$F2psBegin\n");
  fprintf(fOutput,"10 setmiterlimit\n");
  fprintf(fOutput," 0.06000 0.06000 sc\n");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /* Z axis 1*/
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  700,4000);
  fprintf(fOutput,"1.00 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  750,4000,
	  650,4000,
	  700,3850);

  /* Z axis 2*/
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,3000,
	  700,0);
  fprintf(fOutput,"1.00 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  750,0,
	  650,0,
	  700,-150);



  /* labeling Z axis 1 */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);
  
  iMaxInv = (int)(eMaxInv*11000.0);
  while(iMaxInv % 10 != 0){
    iMaxInv++;
  }
  if(labs(iMaxInv) > 1000){
    while(iMaxInv % 100 != 0){
      iMaxInv += 10;
    }
  }
  if(iMaxInv > 11000){
    iMaxInv = 11000;
  }
  /*  printf("iMaxInv: %d\n",iMaxInv);*/

  iZstep = 0;
  while(iZstep < iMaxInv){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%.2f) col0 sh gr\n",
	    700-(int)(sqrt(eFontsc)*sprintf(cTemp,"%.2f",(double)iZstep/10000.0)*10),
	    (int)(7050.0-iZstep*3000.0/((double)(iMaxInv))),
	    (double)iZstep/10000.0);
    fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	    650,(int)(7000.0-iZstep*3000.0/((double)(iMaxInv))),
	    700,(int)(7000.0-iZstep*3000.0/((double)(iMaxInv))));
   
    if(iMaxInv > 3000){
      iZstep += 2000;
    }
    else if(iMaxInv > 300){
      iZstep += 200;
    }
    else if(iMaxInv > 30){
      iZstep += 20;
    }
    else{
      iZstep += 2;
    }
  }

  /* labeling Z axis 2 */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);
  
  iMaxTrans = (int)(eMaxTrans*11000.0);
  while(iMaxTrans % 10 != 0){
    iMaxTrans++;
  }
  if(labs(iMaxTrans) > 1000){
    while(iMaxTrans % 100 != 0){
      iMaxTrans += 10;
    }
  }
  if(iMaxTrans > 11000){
    iMaxTrans = 11000;
  }
  /*  printf("iMaxTrans: %d\n",iMaxTrans);*/

  iZstep = 0;
  while(iZstep < iMaxTrans){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%.2f) col0 sh gr\n",
	    700-(int)(sqrt(eFontsc)*sprintf(cTemp,"%.2f",(double)iZstep/10000.0)*10),
	    (int)(3050.0-iZstep*3000.0/((double)(iMaxTrans))),
	    (double)iZstep/10000.0);
    fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	    650,(int)(3000.0-iZstep*3000.0/((double)(iMaxTrans))),
	    700,(int)(3000.0-iZstep*3000.0/((double)(iMaxTrans))));
    if(iMaxTrans > 3000){
      iZstep += 2000;
    }
    else if(iMaxTrans > 300){
      iZstep += 200;
    }
    else if(iMaxTrans > 30){
      iZstep += 20;
    }
    else{
      iZstep += 2;
    }
  }

  /* X axis 1*/

  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  10900,7000);
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  11050,7000,
	  10900,6950,
	  10900,7050);
  
  /* printf("iBegin: %d\n",iBegin);*/
  for(iI = 0; iI < iImax; iI++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%d) col0 sh gr\n",
	    700+(int)((iI + 0.5) * 10000.0/(iImax)), 
	    7000 + (int)(sqrt(eFontsc)*16.0),
	    iI+1);
  }
 
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",300.0);
  fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	  5000,4000,
	  "Inversion");

  /* X axis 2*/

  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,3000,
	  10900,3000);
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  11050,3000,
	  10900,2950,
	  10900,3050);
  
  /* printf("iBegin: %d\n",iBegin);*/
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);
  for(iI = 0; iI < iImax; iI++){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%d) col0 sh gr\n",
	    700+(int)((iI + 0.5) * 10000.0/(iImax)), 
	    3000 + (int)(sqrt(eFontsc)*16.0),
	    iI+1);
  }

  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",300.0);
  fprintf(fOutput,"%d %d m gs 1 -1 sc (%s) col0 sh gr\n",
	  5000,0,
	  "Transposition");

  /* Data */
  /*  printf("iMin: %d, iMax: %d\n",iMin, iMax);
      printf("eMin: %e, eMax: %e\n",eMin, eMax);*/
  fprintf(fOutput,"1.000 slw\n");
  for(iI = 0; iI < iImax; iI++){
    if(iMaxInv > 0){
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col1 1.00 shd ef gr gs col0 s gr\n",
	      700+(int)(iI * 10000.0/(iImax)),
	      7000,
	      700+(int)(iI * 10000.0/(iImax)),
	      (int)(7000.0-eStatInv[iI]*30000000.0/(double)iMaxInv),
	      700+(int)((iI + 1) * 10000.0/(iImax)),
	      (int)(7000.0-eStatInv[iI]*30000000.0/(double)iMaxInv),
	      700+(int)((iI + 1) * 10000.0/(iImax)),
	      7000);
    }
    if(iMaxTrans > 0){
      fprintf(fOutput,"n %d %d m %d %d l %d %d l %d %d l cp gs col1 1.00 shd ef gr gs col0 s gr\n",
	      700+(int)(iI * 10000.0/(iImax)),
	      3000,
	      700+(int)(iI * 10000.0/(iImax)),
	      (int)(3000.0-eStatTrans[iI]*30000000.0/(double)iMaxTrans),
	      700+(int)((iI + 1) * 10000.0/(iImax)),
	      (int)(3000.0-eStatTrans[iI]*30000000.0/(double)iMaxTrans),
	      700+(int)((iI + 1) * 10000.0/(iImax)),
	      3000);
    }    
  } 

  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/

  /* at the end */
  fprintf(fOutput,"$F2psEnd\n");
  fprintf(fOutput,"rs\n");
  fprintf(fOutput,"showpage\n");

  free(eStatInv);
  free(eStatTrans);

  return(0);
}
