/*
  Partial Importance sampler for Genome Rearrangement. (c) Istvan Miklos
  2003/10/26  : started writing from BasIS.c
                proposalsetep unfinished, just copied from newstep
  2003/10/30  : finishing proposal step
  2003/10/31  : debugging
  2003/12/07  : debugging
  2004/01/12  : found a nasty bug (devided by zero, tough 0! = 1 ...)
  2004/01/14  : writing actual trajectories to output
  2004/02/02  : mitochondria input sequences
  2004/03/05  : eliminating the problem with input data conversion
  2004/03/09  : started writing the program for webserver
  2004/03/30  : writing the web-server part
  2004/05/20  : cCircular switcher
  2004/07/29  : static external arrays for good and supergood mutation lists
  2004/08/24  : static external arrays for variables needed to sample inversions
  2005/02/21  : preventing overload of history arrays 
                (no acceptance of histories more than 2XX- 2 long)
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define XX 1100
#define WINDOW 0.95

static int **iGoodtranslist, **iGoodinvtranslist1, **iGoodinvtranslist2;
static int **iSuperGoodtranslist, **iSuperGoodinvtranslist1, **iSuperGoodinvtranslist2;
static int *iKum0, *iKumPlus1, *iKumMinus11, *iKumMinus12;
static int **iListofpositives, **iListofnegatives;


int main(int iArg, char** cArg){  

  extern int **iGoodtranslist, **iGoodinvtranslist1, **iGoodinvtranslist2;
  extern int **iSuperGoodtranslist, **iSuperGoodinvtranslist1, **iSuperGoodinvtranslist2;
  extern int *iKum0, *iKumPlus1, *iKumMinus11, *iKumMinus12;
  extern int **iListofpositives, **iListofnegatives;

  long int rand();
  void srand();
  FILE  *fInp1, *fInp2, *fOut, *fPosterior, *fLength, *fBreakpoint, *fTrajectory;
  int iPermutation[2 * XX + 2],iOldPermutation[2 * XX + 2],iTempperm[2 * XX + 2];
  int **iStatistics,**iLength,**iBreakpoint;
  long int iTotalInversion, iTotalTransposition;
  long int iIteration, iSamplesize;
  int iInversionMax,iTranspositionMax;
  double eNewtrajectory(int[2 * XX + 2],
			int[2 * XX][4],
			int*,
			int);
  double eBackproposal(int[2 * XX + 2],
			int[2 * XX][4],
			int,
		       int);
  double eTemp, eTemp1, eHastings;
  int iAcceptance, iRealAcceptance, iBegin, iEnd;
  int iIntrand(int);
  int iMin(int,int);
  void Min2from3(int,int,int,int*,int*);
  void Swap(int*,
	    int*);
  void Reversion(int[2 * XX + 2],
		 int,
		 int,
		 int);
  void Transposition(int[2 * XX + 2],
		     int,
		     int,
		     int,
		     int);
  void Invtransposition1(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void Invtransposition2(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void BreakpointStatistics(int*,
			    int,
			    int,
			    int,
			    int**,
			    int);
  double eGibbsalfa(int, int), eGibbsbeta(int, int), eAlfa, eBeta;
  int iHistory[2 * XX][4],iOldHistory[2 * XX][4],iHistoryLength, iOldLength;
  int iI, iJ, iK, iN, iM, iTemp1, iTemp2;
  int iB1, iB2, iB3;
  int iDirection1[XX+1],iDirection2[XX+1],iNumberofgenes1,iNumberofgenes2;
  char cName1[XX + 1][20],cName2[XX + 1][20],cTemp;
  int iTest();
  int iXX;
  char cInput[30],cOutfilename[30];
  int iChecker;
  long int iLongTemp, iLongTemp1;

  /* switch variables */
  char cOutput,cPosterior,cLength,cBreakpoint,cTrajectory,cSilent,cCircular;
  long int iBurnin, iTotalsample, iTotaliteration, iSeed;
  char cProcessname[50];

  /* Just not to get warnings on initialisation */
  fOut = (FILE*) 0;
  fLength = (FILE*) 0;
  fPosterior = (FILE*) 0;
  fBreakpoint = (FILE*) 0;
  fTrajectory = (FILE*) 0;
  iStatistics = (int**) 0;
  iLength = (int**) 0;
  iBreakpoint = (int**) 0;
  iOldLength = 0;

  /* Reading process name */

  if(iArg > 1){
    sscanf(cArg[1],"%s",cProcessname);
  }
  else{
    sprintf(cProcessname,"default");
  }
  /*Reading the genomes*/
  if(iArg > 2){
    sscanf(cArg[2],"%s",cInput);
  }
  else{
    sprintf(cInput,"%dmitochondria.txt",0);
  }
  fInp1 = fopen(cInput,"r");
  if(iArg > 3){
    sscanf(cArg[3],"%s",cInput);
  }
  else{
    sprintf(cInput,"%dmitochondria.txt",1);
  }
  fInp2 = fopen(cInput,"r");
  iChecker = 0;
  while(((cTemp = getc(fInp1)) != '\n')&&
	iChecker < 5000){
    iChecker++;
  }
  cTemp = getc(fInp1);
  iNumberofgenes1 = 0;
  while(cTemp == '+' || cTemp == '-'){
    if(cTemp == '+'){
      iDirection1[iNumberofgenes1] = 1;
    }
    else{
      iDirection1[iNumberofgenes1] = -1;
    }
    iI = 0;
    while(((cName1[iNumberofgenes1][iI] = getc(fInp1)) != '\n')&&
	  iI < 20){
      iI++;
    }
    cName1[iNumberofgenes1][iI] = '\0';
    cTemp = getc(fInp1);
    iNumberofgenes1++;
  }

  if(iNumberofgenes1 == 0){
    sprintf(cName1[0],"1");
    iDirection1[0] = 1;
    iNumberofgenes1 = 1;
  }
  
  iChecker = 0;
  while(((cTemp = getc(fInp2)) != '\n')&&
	iChecker < 5000){
    iChecker++;
  }
  cTemp = getc(fInp2);
  iNumberofgenes2 = 0;
  while(cTemp == '+' || cTemp == '-'){
    if(cTemp == '+'){
      iDirection2[iNumberofgenes2] = 1;
    }
    else{
      iDirection2[iNumberofgenes2] = -1;
    }
    iI = 0;
    while(((cName2[iNumberofgenes2][iI] = getc(fInp2)) != '\n')&&
	  iI < 20){
      iI++;
    }
    cName2[iNumberofgenes2][iI] = '\0';
    cTemp = getc(fInp2);
    iNumberofgenes2++;
  }

  if(iNumberofgenes2 == 0){
    sprintf(cName2[0],"1");
    iDirection2[0] = 1;
    iNumberofgenes2 = 1;
  }

  fclose(fInp1);
  fclose(fInp2);
  
  /* creating the permutation */
  /* finding the common genes, row 'permutation'*/
  
  for(iI = 0; iI < iNumberofgenes2; iI++){
    iTempperm[iI] = -1000;
  }
  
  iK = 0;
  for(iI = 0; iI < iNumberofgenes1; iI++){
    iJ = 0;
    while(iTest(cName1[iI],cName2[iJ]) == 0 && iJ < iNumberofgenes2){
      iJ++;
    } 
    if(iJ < iNumberofgenes2){
      if(iTempperm[iJ] == -1000){
	iK++;
	if(iDirection1[iI] == iDirection2[iJ]){
	  iTempperm[iJ] = iK;
	}
	else{
	  iTempperm[iJ] = -iK;
	}
      }
    }
  }
  
  /* cutting out -1000's*/
  
  for(iI = 0; iI < iNumberofgenes2; iI++){
    if(iTempperm[iI] == -1000){
      iNumberofgenes2--;
      for(iJ = iI; iJ < iNumberofgenes2; iJ++){
	iTempperm[iJ] = iTempperm[iJ + 1];
	sprintf(cName2[iJ],"%s",cName2[iJ + 1]);
      }
      iI--;
    }
  }

  /* writing names back to Name1 */
  for(iI = 0; iI < iNumberofgenes2; iI++){
    sprintf(cName1[iI],"%s",cName2[abs(iTempperm[iI])-1]);
    /*    printf("%d %s\n",iTempperm[iI],cName2[abs(iTempperm[iI])-1]);*/
  }

  /* transforming it into nonsigned permutation*/
  
  iXX = iNumberofgenes2;
  /*  iPermutation = (int*) malloc(sizeof(int)*(2 * iXX + 2));*/
  
  iPermutation[0] = 0;
  iPermutation[2 * iXX + 1] = 2 * iXX + 1;
  for(iI = 0; iI < iNumberofgenes2; iI++){
    if(iTempperm[iI] > 0){
      iPermutation[2 * iI + 1] = 2 * iTempperm[iI] - 1;
      iPermutation[2 * iI + 2] = 2 * iTempperm[iI];
    }
    else{
      iPermutation[2 * iI + 1] = -2 * iTempperm[iI];
      iPermutation[2 * iI + 2] = -2 * iTempperm[iI] - 1;      
    }
  }
  
  /* We need at least 2-long genomes !!!*/

  if(iXX < 2){
    iXX = 2;
    iPermutation[0] = 0;
    iPermutation[1] = 1;
    iPermutation[2] = 2;
    iPermutation[3] = 3;
    iPermutation[4] = 4;
    iPermutation[5] = 5;
  }  
  
  /* Memory allocation */

  iLongTemp = ((long int)iXX*(iXX + 1)*(iXX - 1)/6 < 1000000L)?(long int)iXX*(iXX + 1)*(iXX - 1)/6:1000000L;
  /*  printf("iLongTemp: %ld\n",iLongTemp);*/
  iGoodtranslist = (int**) malloc(iLongTemp*sizeof(int*));
  iGoodinvtranslist1 = (int**) malloc(iLongTemp*sizeof(int*));
  iGoodinvtranslist2 = (int**) malloc(iLongTemp*sizeof(int*));
  iSuperGoodtranslist = (int**) malloc(iLongTemp*sizeof(int*));
  iSuperGoodinvtranslist1 = (int**) malloc(iLongTemp*sizeof(int*));
  iSuperGoodinvtranslist2 = (int**) malloc(iLongTemp*sizeof(int*));
  for(iLongTemp1 = 0; iLongTemp1 < iLongTemp; iLongTemp1++){
    iGoodtranslist[iLongTemp1] = (int*) malloc(3*sizeof(int));
    iGoodinvtranslist1[iLongTemp1] = (int*) malloc(3*sizeof(int));
    iGoodinvtranslist2[iLongTemp1] = (int*) malloc(3*sizeof(int));
    iSuperGoodtranslist[iLongTemp1] = (int*) malloc(3*sizeof(int));
    iSuperGoodinvtranslist1[iLongTemp1] = (int*) malloc(3*sizeof(int));
    iSuperGoodinvtranslist2[iLongTemp1] = (int*) malloc(3*sizeof(int));
  }

  iKum0 = (int*) malloc((iXX + 2)*sizeof(int));
  iKumPlus1 = (int*) malloc((iXX + 2)*sizeof(int));
  iKumMinus11 = (int*) malloc((iXX + 2)*sizeof(int));
  iKumMinus12 = (int*) malloc((iXX + 2)*sizeof(int));
  iListofpositives = (int**) malloc((iXX + 2)*sizeof(int*));
  iListofnegatives = (int**) malloc((iXX + 2)*sizeof(int*));
  for(iI = 0; iI < iXX + 2; iI++){
    iListofpositives[iI] = (int*) malloc((iXX + 2)*sizeof(int));
    iListofnegatives[iI] = (int*) malloc((iXX + 2)*sizeof(int));
  }

  /* Initialising */

  iBurnin = 10000;
  iTotalsample = 1000;
  iTotaliteration = 1000;
  iSeed = 0;
  cOutput = 0;
  cPosterior = 0;
  cLength = 0;
  cBreakpoint = 0;
  cTrajectory = 0;
  cSilent = 0;
  cCircular = 0;

  /* reading switches */
  iI = 4;
  while(iI < iArg){
    sscanf(cArg[iI],"%s",cInput);
    if(cInput[0] == '-'){
      if(cInput[1] == 'o'){
	cOutput = 1;
      }
      else if(cInput[1] == 'p'){
	cPosterior = 1;
      }
      else if(cInput[1] == 'l'){
	cLength = 1;
      }
      else if(cInput[1] == 'b'){
	cBreakpoint = 1;
      }
      else if(cInput[1] == 't'){
	cTrajectory = 1;
      }
      else if(cInput[1] == 's'){
	cSilent = 1;
      }
      else if(cInput[1] == 'c'){
	cCircular = 1;
      }
      else if(cInput[1] == 'B'){
	if(iI + 1 < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing burnin number!\n");	    
	  }
	  else{
	    sscanf(cInput,"%ld",&iBurnin);
	    iI++;
	  }
	}
	else{
	  printf("Missing burnin number!\n");
	}      
      }
      else if(cInput[1] == 'T'){
	if(iI + 1 < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing number of total samples!\n");	    
	  }
	  else{
	    sscanf(cInput,"%ld",&iTotalsample);
	    iI++;
	  }
	}
	else{
	  printf("Missing number of total samples!\n");
	}      
      }
      else if(cInput[1] == 'I'){
	if(iI + 1 < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing number of iterations!\n");	    
	  }
	  else{
	    sscanf(cInput,"%ld",&iTotaliteration);
	    iI++;
	  }
	}
	else{
	  printf("Missing number of iterations!\n");
	}      
      }
      else if(cInput[1] == 'S'){
	if(iI + 1 < iArg){
	  sscanf(cArg[iI + 1],"%s",cInput);
	  if(cInput[0] == '-'){
	    printf("Missing rand seed!\n");	    
	  }
	  else{
	    sscanf(cInput,"%ld",&iSeed);
	    iI++;
	  }
	}
	else{
	  printf("Missing rand seed!\n");
	}      
      }
      else{
	printf("Unknown command! %s\n",cArg[iI]);
      }

    }
    else{
      printf("Unknown command! %s\n",cArg[iI]);
    }
    iI ++;
  }

  /* opening output files, allocating memory */

  if(cOutput == 1){
    sprintf(cOutfilename,"%s.log",cProcessname);
    fOut = fopen(cOutfilename,"w");
  }
  if(cTrajectory == 1){
    sprintf(cOutfilename,"%s.trajectory",cProcessname);
    fTrajectory = fopen(cOutfilename,"w");
  }
  if(cPosterior == 1){
    sprintf(cOutfilename,"%s.posterior",cProcessname);
    fPosterior = fopen(cOutfilename,"w");
    /*Allocating memory*/
    iStatistics = (int**) malloc((2 * iXX)*sizeof(int*));
    for(iI = 0; iI < 2 * iXX + 2; iI++){
      iStatistics[iI] = (int*) malloc((2 * iXX)*sizeof(int));
    }
  }
  if(cLength == 1){
    sprintf(cOutfilename,"%s.length",cProcessname);
    fLength = fopen(cOutfilename,"w");
    /*Allocating memory*/
    iLength = (int**) malloc((2)*sizeof(int*));
    for(iI = 0; iI < 2; iI++){
      iLength[iI] = (int*) malloc((iXX + 1)*sizeof(int));
    }
  }
  if(cBreakpoint == 1){
    sprintf(cOutfilename,"%s.breakpoint",cProcessname);
    fBreakpoint = fopen(cOutfilename,"w");
    /*Allocating memory*/
    iBreakpoint = (int**) malloc(2 * sizeof(int*));
     for(iI = 0; iI < 2; iI++){
      iBreakpoint[iI] = (int*) malloc((iXX)*sizeof(int));
    }   
  }
    
  srand(iSeed);

  if(cOutput == 1){
    for(iI = 0; iI < 2 * iXX + 2; iI++){
      fprintf(fOut,"%d ",iPermutation[iI]);
    }
    fprintf(fOut,"\n");
    for(iI = 0; iI < iXX; iI++){
      fprintf(fOut,"%s ",cName2[iI]);
    }
    fprintf(fOut,"\n                %ld\n",iTotalsample);
  }

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iOldPermutation[iI] = iPermutation[iI];
  }
  
  /* Bayesian importance sampler part */
  
  /* set the statistics to 0 */
  
  if(cPosterior == 1){
    for(iI = 0; iI < 2 * iXX; iI++){
      for(iJ = 0; iJ < 2 * iXX; iJ ++){
	iStatistics[iI][iJ] = 0;
      }
    }
  }
  if(cLength == 1){
    for(iI = 0; iI < 2; iI++){
      for(iJ = 0; iJ < iXX + 1; iJ ++){
	iLength[iI][iJ] = 0;
      }
    }
  }
  if(cBreakpoint == 1){
    for(iI = 0; iI < 2; iI++){
      for(iJ = 0; iJ < iXX + 1; iJ ++){
	iBreakpoint[iI][iJ] = 0;
      }
    }
  }
  iTotalInversion = 0;
  iTotalTransposition = 0;
  
  /* sampling */
  /* First sample */

  iIteration = 0;
  eHastings = 0.0;
  while(eHastings  == 0.0){
    eHastings = 1.0/eNewtrajectory(iPermutation,iOldHistory,&iHistoryLength,iXX);
    if(iHistoryLength == 2 * iXX){
      if(cSilent == 0){
	printf("Too bad rearrangement!\n");
      }
      eHastings = 0.0;
    }
    else{
      iOldLength = iHistoryLength;
      if(cSilent == 0){
	printf("Good rearrangement!\n");
      }
    }
  }
  
  /* First Gibbs sampling of alpha and beta */
  iM = 0;
  iN = 0;
  for(iJ = 0; iJ < iOldLength; iJ++){
    if(iOldHistory[iJ][0] == 3){
      iM++;
    }
    else{
      iN++;
    }
  }

  eAlfa = eGibbsalfa(iM,iXX);
  eBeta = eGibbsbeta(iN,iXX);
  
  /* Iteration */
  iAcceptance = 0;
  iRealAcceptance = 0;
  iSamplesize = -iBurnin;
  iIteration = 0;
  while(iSamplesize < iTotalsample){
    /* Finding the new sampling step */
    /* window */

    iI = 0;
    while((double)rand()/(double)RAND_MAX < WINDOW && iI < iOldLength){
      
      iI++;
    }
    iBegin = iIntrand(iOldLength - iI + 1);
    iEnd = iBegin + iI;
    /* cuting out the history + creating permutation */
    for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
      iPermutation[iJ]=iJ;
    }
    for(iJ = 0; iJ < iI; iJ++){
      iHistory[iJ][0] = iOldHistory[iBegin + iJ][0];
      iHistory[iJ][1] = iOldHistory[iBegin + iJ][1];
      iHistory[iJ][2] = iOldHistory[iBegin + iJ][2];
      iHistory[iJ][3] = iOldHistory[iBegin + iJ][3];
    }
    for(iJ = iI - 1; iJ >= 0; iJ--){
      if(iHistory[iJ][0] == 0){
	Transposition(iPermutation,
		      iHistory[iJ][1],
		      iHistory[iJ][1] + iHistory[iJ][3] - iHistory[iJ][2],
		      iHistory[iJ][3],
		      iXX);
      }
      else if(iHistory[iJ][0] == 1){
	Invtransposition2(iPermutation,
			  iHistory[iJ][1],
			  iHistory[iJ][1] + iHistory[iJ][3] - iHistory[iJ][2],
			  iHistory[iJ][3],
			  iXX);
      }
      else if(iHistory[iJ][0] == 2){
	Invtransposition1(iPermutation,
			  iHistory[iJ][1],
			  iHistory[iJ][1] + iHistory[iJ][3] - iHistory[iJ][2],
			  iHistory[iJ][3],
			  iXX);
      }
      else{
	Reversion(iPermutation,
		  iHistory[iJ][1],
		  iHistory[iJ][2],
		  iXX);
      }
    }
    
    /* Calling the backproposal probability calculator */
    /* printf("\ncalling the backproposal\n");*/
    /*    printf("Begin:%d\n",iBegin);*/
    /*    for(iJ = 0; iJ < iI; iJ++){
	  printf("type: %d, x: %d, y: %d, z: %d\n",
	  iHistory[iJ][0],
	  iHistory[iJ][1],
	  iHistory[iJ][2],
	  iHistory[iJ][3]);
	  }
    */
    eHastings = log(eBackproposal(iPermutation,iHistory,iI,iXX));
    eHastings -= log(pow((double)WINDOW,(double)iI));
    /* Involving the old likelihood */
    iM = 0;
    iN = 0;
    for(iJ = 0; iJ < iOldLength; iJ++){
      if(iOldHistory[iJ][0] == 3){
	iM++;
      }
      else{
	iN++;
      }
    }
    eHastings -= -eAlfa * (iXX + 1.0) * iXX / 2.0 - eBeta * (iXX + 1.0) * iXX * (iXX-1.0) / 2.0;
    for(iJ = 1; iJ <= iM; iJ++){
      eHastings -= log(eAlfa)-log((double)iJ);
    }
    for(iK = 1; iK <= iN; iK++){
      eHastings -= log(eBeta)-log((double)(iK + iM));
    }
    /* new trajectory + new proposal prob. */
    for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
      iTempperm[iJ] = iPermutation[iJ];
      /*      printf("%d ",iTempperm[iJ]);*/
    }
    /*    printf("\n");*/
    eTemp = eNewtrajectory(iPermutation,iHistory,&iHistoryLength,iXX);
    eHastings -= log(eTemp);
    eHastings += log(pow((double)WINDOW,(double)iHistoryLength));
    /* printf("\nCheck:\n");*/
    eTemp1 = eBackproposal(iTempperm,iHistory,iHistoryLength,iXX);
    /*    printf("Temp: %e  Temp1: %e\n",eTemp,eTemp1);*/
    if(fabs(eTemp - eTemp1) > 0.00001){
      if(cSilent == 0){
	printf("problem with backproposal!\n");
	printf("Temp: %e  Temp1: %e\n",eTemp,eTemp1);
	scanf("%d",&iI);
      }
    }
    /*
      for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
      printf("%d ",iTempperm[iJ]);
      }
    */
    /*    printf("\n");*/
    
    /* new likelihood probability */
    if(iOldLength - iI + iHistoryLength > 2 * iXX){
      /* printf("Too bad rearrangement!\n");*/
    }
    else{
      iM = 0;
      iN =0;
      for(iJ = 0; iJ < iBegin; iJ++){
	if(iOldHistory[iJ][0] == 3){
	  iM++;
	}
	else{
	  iN++;
	}
      }
      for(iJ = 0; iJ < iHistoryLength; iJ++){
	if(iHistory[iJ][0] == 3){
	  iM++;
	}
	else{
	  iN++;
	}
      }
      for(iJ = iEnd; iJ < iOldLength; iJ++){
	if(iOldHistory[iJ][0] == 3){
	  iM++;
	}
	else{
	  iN++;
	}
      }
      /*      printf("M = %d N = %d\n",iM,iN);*/
      
      eHastings += -eAlfa * (iXX + 1.0) * iXX / 2.0 - eBeta * (iXX + 1.0) * iXX * (iXX-1.0) / 2.0;
      for(iJ = 1; iJ <= iM; iJ++){
	eHastings += log(eAlfa)-log((double)iJ);
      }
      for(iK = 1; iK <= iN; iK++){
	eHastings += log(eBeta)-log((double)(iK + iM));
      }
      
      eHastings = exp(eHastings);
      
      /*      if(eHastings >1.001){
	      printf("Hastings ratio: %e, i: %d\n",eHastings,iI);
	      }
      */

      if((double)rand()/(double)RAND_MAX < eHastings &&
	 iOldLength + iHistoryLength - iI < 2 * iXX - 2){
	iAcceptance++;
	if(iI > iHistoryLength){
	  for(iJ = iEnd; iJ < iOldLength; iJ++){
	    iOldHistory[iJ + iHistoryLength - iI][0] = iOldHistory[iJ][0];
	    iOldHistory[iJ + iHistoryLength - iI][1] = iOldHistory[iJ][1];
	    iOldHistory[iJ + iHistoryLength - iI][2] = iOldHistory[iJ][2];
	    iOldHistory[iJ + iHistoryLength - iI][3] = iOldHistory[iJ][3];
	  }
	}
	else{
	  for(iJ = iOldLength - 1; iJ >= iEnd; iJ--){
	    iOldHistory[iJ + iHistoryLength - iI][0] = iOldHistory[iJ][0];
	    iOldHistory[iJ + iHistoryLength - iI][1] = iOldHistory[iJ][1];
	    iOldHistory[iJ + iHistoryLength - iI][2] = iOldHistory[iJ][2];
	    iOldHistory[iJ + iHistoryLength - iI][3] = iOldHistory[iJ][3];
	  }
	}
	for(iJ = 0; iJ < iHistoryLength; iJ++){
	  iOldHistory[iBegin + iJ][0] = iHistory[iJ][0];
	  iOldHistory[iBegin + iJ][1] = iHistory[iJ][1];
	  iOldHistory[iBegin + iJ][2] = iHistory[iJ][2];
	  iOldHistory[iBegin + iJ][3] = iHistory[iJ][3];
	}
	iOldLength += iHistoryLength - iI;
	if(fabs(eHastings - 1.0) > 0.001){
	  iRealAcceptance++;
	}
	/* checking that the trajectory is correct */
	/*	printf("Check\n");*/
	for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
	  iPermutation[iJ] = iOldPermutation[iJ];
	}
	for(iJ = 0; iJ < iOldLength; iJ++){
	  if(iOldHistory[iJ][0] == 0){
	    Transposition(iPermutation,
			  iOldHistory[iJ][1],
			  iOldHistory[iJ][2],
			  iOldHistory[iJ][3],
			  iXX);
	  }
	  else if(iOldHistory[iJ][0] == 1){
	    Invtransposition1(iPermutation,
			      iOldHistory[iJ][1],
			      iOldHistory[iJ][2],
			      iOldHistory[iJ][3],
			      iXX);
	  }
	  else if(iOldHistory[iJ][0] == 2){
	    Invtransposition2(iPermutation,
			      iOldHistory[iJ][1],
			      iOldHistory[iJ][2],
			      iOldHistory[iJ][3],
			      iXX);	    
	  }
	  else{
	    Reversion(iPermutation,
		      iOldHistory[iJ][1],
		      iOldHistory[iJ][2],
		      iXX);
	  }
	}
	for(iI = 0; iI < 2 * iXX + 2; iI++){
	  if(iPermutation[iI] != iI){
	    printf("Check!!!\n");
	    for(iI = 0; iI < 2 * iXX + 2; iI++){
	      printf("%d ",iPermutation[iI]);
	    }
	    printf("\n");
	    for(iI = 0; iI < 2 * iXX + 2; iI++){
	      printf("%d ",iOldPermutation[iI]);
	    }
	    printf("\n");
	    scanf("%d\n",&iJ);
	  }
	}       
      }
      iIteration++;
      if(iSamplesize < 0){
	iSamplesize++;
	iIteration = 0;
      }
      if(iIteration >= iTotaliteration){
	iSamplesize++;
	iIteration = 0;
	iM = 0;
	iN = 0;
	for(iI = 0; iI < iOldLength; iI++){
	  if(iOldHistory[iI][0] == 3){
	    iM++;
	  }
	  else{
	    iN++;
	  }
	}
	iTotalInversion += iM;
	iTotalTransposition += iN;
	if(cLength == 1){
	  for(iJ = 0; iJ < iOldLength; iJ++){
	    if(iOldHistory[iJ][0] == 3){
	      if(cCircular ==0){
		iLength[1][iOldHistory[iJ][2] - iOldHistory[iJ][1]]++;
	      }
	      else{
		iLength[1][iMin(iOldHistory[iJ][2] - iOldHistory[iJ][1],
				iXX - (iOldHistory[iJ][2] - iOldHistory[iJ][1]))]++;
	      }
	    }
	    else{
	      if(cCircular ==0){
		iLength[0][iOldHistory[iJ][3] - iOldHistory[iJ][2]]++;
		iLength[0][iOldHistory[iJ][2] - iOldHistory[iJ][1]]++;
	      }
	      else{
		Min2from3(iOldHistory[iJ][3] - iOldHistory[iJ][2],
			  iOldHistory[iJ][2] - iOldHistory[iJ][1],
			  iXX - (iOldHistory[iJ][3] - iOldHistory[iJ][1]),
			  &iTemp1,
			  &iTemp2);
		iLength[0][iTemp1]++;
		iLength[0][iTemp2]++;
	      }
	    }
	  }  
	}
	eTemp = -eAlfa * (iXX + 1.0) * iXX / 2.0 - eBeta * (iXX + 1.0) * iXX * (iXX-1.0) / 2.0;
	for(iJ = 1; iJ <= iM; iJ++){
	  eTemp += log(eAlfa)-log((double)iJ);
	}
	for(iK = 1; iK <= iN; iK++){
	  eTemp += log(eBeta)-log((double)(iK + iM));
	}
	
	/*	eTemp = exp(eTemp);*/
	if(cOutput == 1){
	  fprintf(fOut,
		  "Sample: %ld M = %d N = %d alfa = %e beta = %e eTemp = %e Acceptance = %d, RealAcceptance: %d\n",
		  iSamplesize,
		  iM,
		  iN,
		  eAlfa,
		  eBeta,
		  eTemp,
		  iAcceptance,
		  iRealAcceptance);
	}
	if(cTrajectory == 1){
	  for(iJ = 0; iJ < iOldLength; iJ++){
	    if(iOldHistory[iJ][0] == 3){
	      fprintf(fTrajectory,"%d %3d %3d    |",iOldHistory[iJ][0],iOldHistory[iJ][1],iOldHistory[iJ][2]);
	    }
	    else{
	      fprintf(fTrajectory,"%d %3d %3d %3d|",iOldHistory[iJ][0],iOldHistory[iJ][1],iOldHistory[iJ][2],iOldHistory[iJ][3]);
	    }
	  }
	  fprintf(fTrajectory,"\n");
	}
	if(cSilent == 0){
	  printf("Sample: %ld M = %d N = %d alfa = %e beta = %e eTemp = %e Acceptance = %d, RealAcceptance: %d\n",
		 iSamplesize,
		 iM,
		 iN,
		 eAlfa,
		 eBeta,
		 eTemp,
		 iAcceptance,
		 iRealAcceptance);
	}
	/********************************************/
	if(cBreakpoint == 1){
	  for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
	    iPermutation[iJ]=iJ;
	  }
	  for(iJ = iOldLength - 1; iJ >= 0; iJ--){
	    if(iOldHistory[iJ][0] == 0){
	      iB1 = iOldHistory[iJ][1];
	      iB2 = iOldHistory[iJ][1] + iOldHistory[iJ][3] - iOldHistory[iJ][2];
	      iB3 = iOldHistory[iJ][3];
	      BreakpointStatistics(iPermutation,
				   iB1,
				   iB2,
				   iB3,
				   iBreakpoint,
				   iXX);
	      Transposition(iPermutation,
			    iB1,
			    iB2,
			    iB3,
			    iXX);
	    }
	    else if(iOldHistory[iJ][0] == 1){
	      iB1 = iOldHistory[iJ][1];
	      iB2 = iOldHistory[iJ][1] + iOldHistory[iJ][3] - iOldHistory[iJ][2];
	      iB3 = iOldHistory[iJ][3];
	      BreakpointStatistics(iPermutation,
				   iB1,
				   iB2,
				   iB3,
				   iBreakpoint,
				   iXX);
	      Invtransposition2(iPermutation,
				iB1,
				iB2,
				iB3,
				iXX);
	    }
	    else if(iOldHistory[iJ][0] == 2){
	      iB1 = iOldHistory[iJ][1];
	      iB2 = iOldHistory[iJ][1] + iOldHistory[iJ][3] - iOldHistory[iJ][2];
	      iB3 = iOldHistory[iJ][3];
	      BreakpointStatistics(iPermutation,
				   iB1,
				   iB2,
				   iB3,
				   iBreakpoint,
				   iXX);
	      Invtransposition1(iPermutation,
				iB1,
				iB2,
				iB3,
				iXX);
	    }
	    else{
	      iB1 = iOldHistory[iJ][1];
	      iB2 = iOldHistory[iJ][2];
	      /* iB1 */
	      if(iB1 > 0){
		if(iPermutation[2 * iB1] % 2 == 0){
		  iBreakpoint[1][iPermutation[2 * iB1]/2 - 1]++;
		}
		else{
		  iBreakpoint[0][iPermutation[2 * iB1]/2]++;
		}
	      }
	      if(iPermutation[2 * iB1 + 1] % 2 == 0){
		iBreakpoint[1][iPermutation[2 * iB1 + 1]/2 - 1]++;
	      }
	      else{
		iBreakpoint[0][iPermutation[2 * iB1 + 1]/2]++;
	      }
	      /* iB2 */
	      if(iPermutation[2 * iB2] % 2 == 0){
		iBreakpoint[1][iPermutation[2 * iB2]/2 - 1]++;
	      }
	      else{
		iBreakpoint[0][iPermutation[2 * iB2]/2]++;
	      }
	      if(iB2 < iXX){
		if(iPermutation[2 * iB2 + 1] % 2 == 0){
		  iBreakpoint[1][iPermutation[2 * iB2 + 1]/2 - 1]++;
		}
		else{
		  iBreakpoint[0][iPermutation[2 * iB2 + 1]/2]++;
		}
	      }
	      Reversion(iPermutation,
			iB1,
			iB2,
			iXX);
	    }
	  }
	  for(iI = 0; iI < 2 * iXX + 2; iI++){
	    if(iPermutation[iI] != iOldPermutation[iI]){
	      printf("Hey Huston, we have a problem!\n");
	      for(iI = 0; iI < 2 * iXX + 2; iI++){
		printf("%d ",iPermutation[iI]);
	      }
	      printf("\n");
	      for(iI = 0; iI < 2 * iXX + 2; iI++){
		printf("%d ",iOldPermutation[iI]);
	      }
	      printf("\n");
	      scanf("%d\n",&iJ);
	    }
	  }
	}
	/********************************/
	/*
	  for(iI = 0; iI < 2 * iXX + 2; iI++){
	  printf("%3d ",iPermutation[iI]);
	  fprintf(out,"%3d ",iPermutation[iI]);
	  }
	*/
	iAcceptance = 0;
	iRealAcceptance = 0;
	iIteration = 0;
	if(cPosterior == 1){	  
	  iStatistics[iM][iN]++;
	}
      }
      
      /* Gibbs sampling part */
      
      eAlfa = eGibbsalfa(iM,iXX);
      eBeta = eGibbsbeta(iN,iXX);
      
    }

    /*
    printf("Samplesize = %ld\n",iSamplesize);
    */
  }
  if(cOutput == 1){
    fclose(fOut);
  }
  if(cTrajectory == 1){
    fclose(fTrajectory);
  }

  if(cPosterior == 1){
    /* finding maximum non-zeros in the distribution */
    iInversionMax = 1;
    iTranspositionMax = 1;
    for(iI = 0; iI < iXX; iI++){
      for(iJ = 0; iJ < iXX; iJ ++){
	if(iStatistics[iI][iJ] > 0){
	  if(iInversionMax < iI + 1){
	    iInversionMax = iI + 1;
	  }
	  if(iTranspositionMax < iJ + 1){
	    iTranspositionMax = iJ + 1;
	  }
	}
      }
    }

    fprintf(fPosterior,
	    "%d %d\n",
	    iInversionMax,
	    iTranspositionMax);
    for(iI = 0; iI < iInversionMax; iI++){
      for(iJ = 0; iJ < iTranspositionMax; iJ ++){
	fprintf(fPosterior,"%f ",(double)iStatistics[iI][iJ]/(double)iTotalsample);
      }
      fprintf(fPosterior,"\n");
    }
    fclose(fPosterior);
  }

  if(cLength == 1){
    fprintf(fLength,"%d\nInversion: ",(cCircular==0?iXX:iXX/2));
    for(iI = 1; iI <= (cCircular==0?iXX:iXX/2); iI++){
      fprintf(fLength,"%f ",iTotalInversion>0?(double)iLength[1][iI]/(double)iTotalInversion:0.0);
    }
    fprintf(fLength,"\nTransposition: ");
    for(iI = 1; iI <= (cCircular==0?iXX:iXX/2); iI++){
      fprintf(fLength,"%f ",iTotalTransposition>0?(double)iLength[0][iI]/(double)(2.0*iTotalTransposition):0.0);
    }
    fprintf(fLength,"\n");
    fclose(fLength);
  }
  
  if(cBreakpoint == 1){
    fprintf(fBreakpoint,"%d\n",iXX);
    for(iI = 0; iI < iXX; iI++){
      fprintf(fBreakpoint,
	      "%s %f %f\n",
	      cName1[iI],
	      (double)iBreakpoint[0][iI]/(double)iTotalsample,
	      (double)iBreakpoint[1][iI]/(double)iTotalsample);
    }
    fclose(fBreakpoint);
  }

  for(iLongTemp1 = 0; iLongTemp1 < iLongTemp; iLongTemp1++){
    free(iGoodtranslist[iLongTemp1]);
    free(iGoodinvtranslist1[iLongTemp1]);
    free(iGoodinvtranslist2[iLongTemp1]);
    free(iSuperGoodtranslist[iLongTemp1]);
    free(iSuperGoodinvtranslist1[iLongTemp1]);
    free(iSuperGoodinvtranslist2[iLongTemp1]);
  }
  free(iGoodtranslist);
  free(iGoodinvtranslist1);
  free(iGoodinvtranslist2);
  free(iSuperGoodtranslist);
  free(iSuperGoodinvtranslist1);
  free(iSuperGoodinvtranslist2);

  free(iKum0);
  free(iKumPlus1);
  free(iKumMinus11);
  free(iKumMinus12);
  for(iI = 0; iI < iXX + 2; iI++){
    free(iListofpositives[iI]);
    free(iListofnegatives[iI]);
  }
  free(iListofpositives);
  free(iListofnegatives);

  return(0);
}

double eGibbsalfa(int n, int iXX){
  
  double z, falfa(double, int, int);
  double step,x;
  long int rand();

  step=0.1;
  x=0;
/* pac */
#ifdef _PLAN9
  z=(double)rand()/ (double)RAND_MAX;
#else
  z=(double)rand()/ (double)RAND_MAX;
#endif
  while(step>0.0000000001){
    if(falfa(x,n,iXX)<z){
      x+=step;
    }
    else{
      step=step/2.0;
      x-=step;
    }
  }
  if(x<=0.0){
    x=0.0001;
  }
  return(x);

}

double falfa(double x, int n, int iXX){

  double v,v1;
  int i;
  v=1.0;
  v1=1.0;
  for(i=1;i<=n;i++){
    v=v*x*(iXX + 1.0)*iXX/(i * 2.0);
    v1+=v;
  }

  return(1.0-exp(-x*(iXX+1.0)*iXX/2.0)*v1);
  
}

double eGibbsbeta(int n, int iXX){

  double z, fbeta(double, int, int);
  double step,x;
  long int rand();

  step=0.1;
  x=0;
/* pac */
#ifdef _PLAN9
  z=(double)rand()/ (double)RAND_MAX;
#else
  z=(double)rand()/ (double)RAND_MAX;
#endif
  while(step>0.0000000001){
    if(fbeta(x,n, iXX)<z){
      x+=step;
    }
    else{
      step=step/2.0;
      x-=step;
    }
  }
  if(x<=0.0){
    x=0.0001;
  }

  return(x);

}

double fbeta(double x, int n, int iXX){

  double v,v1;
  int i;
  v=1.0;
  v1=1.0;
  for(i=1;i<=n;i++){
    v=v*x*(iXX + 1.0)*iXX*(iXX-1.0)/(i * 2.0);
    v1+=v;
  }

  return(1.0-exp(-x*(iXX+1.0)*iXX*(iXX-1.0)/2.0)*v1);
  
}


double eNewtrajectory(int iPermutation[2 * XX + 2],
		      int iHistory[2 * XX][4],
		      int *iHistoryLength,
		      int iXX){

  double eZ, eNewstep(int[2 * XX + 2],
		      int[4],
		      int);
  int iTemppermutation[2*XX+2], iI, iSorted;
  int iNewstep[4];
  int iIntrand(int);

  /*  printf("New trajectory\n");*/

  *iHistoryLength = 0;
  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iTemppermutation[iI] = iPermutation[iI];
  }
  eZ = 1.0;
  iSorted = 1;
  for(iI = 0; iI < 2 * iXX + 2; iI++){
    if(iTemppermutation[iI] != iI){
      iSorted=0;
    }
  }
  if(iIntrand(100) == 0 && iSorted == 1){
    eZ *= 0.01;
    iSorted=0;
  }
  while((iSorted == 0) && (*iHistoryLength < 2 * iXX)){
    /*
    printf(".");
    fflush(stdout);
    */
    eZ *= eNewstep(iTemppermutation,iNewstep,iXX);
    iHistory[*iHistoryLength][0] = iNewstep[0];
    iHistory[*iHistoryLength][1] = iNewstep[1];
    iHistory[*iHistoryLength][2] = iNewstep[2];
    iHistory[*iHistoryLength][3] = iNewstep[3];
    (*iHistoryLength)++;
    iSorted = 1;
    for(iI = 0; iI < 2 * iXX + 2; iI++){
      if(iTemppermutation[iI] != iI){
	iSorted=0;
      }
    }
    if(iIntrand(100) == 0 && iSorted == 1){
      eZ *= 0.01;
      iSorted=0;
    }
    
  }
  iSorted = 1;
  for(iI = 0; iI < 2 * iXX + 2; iI++){
    if(iTemppermutation[iI] != iI){
      iSorted=0;
    }
  }
  eZ = eZ * 0.99;
  /*
  printf("Finished!\n\n");
  */
  return(eZ);
}

double eBackproposal(int iPermutation[2 * XX + 2],
		     int iHistory[2 * XX][4],
		     int iHistoryLength,
		     int iXX){

  double eZ, eProposalstep(int[2 * XX + 2],
			   int[4],
			   int);
  int iTempPermutation[2 * XX + 2];
  int iI, iJ, iSorted;
  int iNewstep[4];

  /*  printf("Backproposal\n");*/

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iTempPermutation[iI] = iPermutation[iI];
  }

  iSorted = 1;
  eZ = 1.0;
  for(iI = 0; iI < iHistoryLength; iI++){
    for(iJ = 0; iJ < 2 * iXX + 2; iJ++){
      if(iTempPermutation[iJ] != iJ){
	iSorted=0;
      }
    }
    if(iSorted == 1 && (iI + 1) < iHistoryLength){
      eZ *= 0.01;
    }
    iNewstep[0] = iHistory[iI][0];
    iNewstep[1] = iHistory[iI][1];
    iNewstep[2] = iHistory[iI][2];
    iNewstep[3] = iHistory[iI][3];
    eZ *= eProposalstep(iTempPermutation,iNewstep,iXX);
    iSorted = 1;
  }
    
  eZ = eZ * 0.99;
  return(eZ);
}

double eNewstep(int iPermutation[2 * XX + 2],
		int iHistory[4],
		int iXX){

  int iIntrand();
  void Reversion(int[2 * XX + 2],
		 int,
		 int,
		 int);
  void  Transposition(int[2 * XX + 2],
		      int,
		      int,
		      int,
		      int);
  void Invtransposition1(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void Invtransposition2(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void Swap();
  int iInvpermutation[2*XX+2];
  int iI, iIi, iJ, iK, /*iL,*/ iTemp;
  int iNumberofcycles, iCyclelength[XX+2], iNumberofplus[XX+2],/* iInvcycle[iXX+2],*/ iSign[XX+2], iTraversed[2*XX+2];
  int p[XX+1], iActualsign[XX+1], iCyclenumber[XX+2];
  int iSumsquared, d[XX+1];
  long int iReverseplus, iReverseminus, iReversesame;
  long int iGoodtrans, iGoodinvtrans1, iGoodinvtrans2;
  long int iBadtrans, iBadinvtrans1, iBadinvtrans2;
  extern int **iGoodtranslist, **iGoodinvtranslist1, **iGoodinvtranslist2;
  long int iSuperGoodtrans, iSuperGoodinvtrans1, iSuperGoodinvtrans2;
  extern int **iSuperGoodtranslist, **iSuperGoodinvtranslist1, **iSuperGoodinvtranslist2;
  int iAccepted;
  double eProposal;
  int iGoodall, iSuperGoodall;

  extern int *iKum0, *iKumPlus1, *iKumMinus11, *iKumMinus12;
  extern int **iListofpositives, **iListofnegatives;
  long int iLongTemp;

  iLongTemp = ((long int)iXX*(iXX + 1)*(iXX - 1)/6 < 1000000L)?(long int)iXX*(iXX + 1)*(iXX - 1)/6:1000000L;


  /* printing the permutation */
  /* 
  printf("\n\n");
  for(iI = 0; iI < 2 * iXX + 2; iI++){
    printf("%d ",iPermutation[iI]);
  }
  printf("\n\n");
  */
  /* INVERSE PERMUTATION */

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iInvpermutation[iPermutation[iI]] = iI;
    iTraversed[iI]=0;
  }

  /* DECOMPOSITION TO CYCLES */

  iNumberofcycles=0;
  iIi=0;
  iGoodtrans=0;
  iGoodinvtrans1=0;
  iGoodinvtrans2=0;
  iSuperGoodtrans=0;
  iSuperGoodinvtrans1=0;
  iSuperGoodinvtrans2=0;
  iKum0[0] = 0;
  iKumPlus1[0] = 0;
  iKumMinus11[0] = 0;
  iKumMinus12[0] = 0;

  while(iIi < 2 * iXX + 2){
    
    /* finding the begining of the cycle */

    while(iTraversed[iIi] == 1 && iIi < 2 * iXX + 2){
      iIi++;
    }
    /*
    printf("%d iXX: %d, G0: %ld, G1: %ld, G2:%ld, SG0:%ld, SG1 : %ld SG2: %ld\n",
	   iIi, 
	   iXX,
	   iGoodtrans,
	   iGoodinvtrans1,
	   iGoodinvtrans2,
	   iSuperGoodtrans,
	   iSuperGoodinvtrans1,
	   iSuperGoodinvtrans2);
    fflush(stdout);
    */
    /* traversing the new cycle*/
    
    if(iIi < 2 * iXX + 2){
      iNumberofcycles++;
      iCyclelength[iNumberofcycles - 1] = 0;
      iNumberofplus[iNumberofcycles - 1] = 0;
      iJ = iIi;
      /*      
      printf("l");
      fflush(stdout);
      */
      while(iTraversed[iJ] == 0){
	iTraversed[iJ] = 1;
	iCyclelength[iNumberofcycles - 1]++;
	
	/* finding the next black edge */
	
	if(iJ / 2 == (iJ + 1) / 2){
	  iSign[iJ / 2] = 1;
	  iCyclenumber[iJ / 2] = iNumberofcycles;
	  iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = 1;
	  p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	  iNumberofplus[iNumberofcycles - 1]++;
	  iListofpositives[iNumberofcycles -1][iNumberofplus[iNumberofcycles - 1] - 1] = iJ / 2;
	  iJ++;
	  iTraversed[iJ] = 1;
	}
	else{
	  iJ--;
	  iSign[iJ / 2] = -1;
	  iCyclenumber[iJ / 2] = iNumberofcycles;
	  iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = -1;
	  p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	  iListofnegatives[iNumberofcycles -1][iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1]-1] = iJ / 2;
	  iTraversed[iJ] = 1;
	}
	if(iPermutation[iJ] / 2 == (iPermutation[iJ] + 1) / 2 ){
	  iJ = iInvpermutation[iPermutation[iJ] + 1];
	}
	else{
	  iJ = iInvpermutation[iPermutation[iJ] - 1];
	}
	
      }
      
      /* Obtaining the kumulative functions */ 
      
      iKum0[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iNumberofplus[iNumberofcycles - 1] - 1) + (iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1])*(iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1] - 1);
      iKumPlus1[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iCyclelength[iNumberofcycles - 1] -iNumberofplus[iNumberofcycles - 1]);
      iKumMinus11[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1]*(iXX + 1 - iCyclelength[iNumberofcycles - 1]);
      iKumMinus12[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1];
      if(iNumberofcycles > 1){
	iKum0[iNumberofcycles - 1] += iKum0[iNumberofcycles - 2];
	iKumPlus1[iNumberofcycles - 1] += iKumPlus1[iNumberofcycles - 2];
	iKumMinus11[iNumberofcycles - 1] += iKumMinus11[iNumberofcycles - 2];
	iKumMinus12[iNumberofcycles - 1] += iKumMinus12[iNumberofcycles - 2];
      }
      
      /* investigating long cycles */
      
      if(iCyclelength[iNumberofcycles - 1] > 2){
	for(iI = 0; iI < iCyclelength[iNumberofcycles - 1] - 2; iI++){
	  for(iJ = iI + 1; iJ < iCyclelength[iNumberofcycles - 1] - 1; iJ++){
	    for(iK = iJ + 1; iK < iCyclelength[iNumberofcycles - 1]; iK++){
	      if(iGoodtrans >= iLongTemp){
		iGoodtrans--;
	      }
	      if(iGoodinvtrans1 >= iLongTemp){
		iGoodinvtrans1--;
	      }
	      if(iGoodinvtrans2 >= iLongTemp){
		iGoodinvtrans2--;
	      }
	      if(iSuperGoodtrans >= iLongTemp){
		iSuperGoodtrans--;
	      }
	      if(iSuperGoodinvtrans1 >= iLongTemp){
		iSuperGoodinvtrans1--;
	      }
	      if(iSuperGoodinvtrans2 >= iLongTemp){
		iSuperGoodinvtrans2--;
	      }
	      /*
	      printf("G0: %ld, G1: %ld, G2:%ld, SG0:%ld, SG1 : %ld SG2: %ld\n",
		     iGoodtrans,
		     iGoodinvtrans1,
		     iGoodinvtrans2,
		     iSuperGoodtrans,
		     iSuperGoodinvtrans1,
		     iSuperGoodinvtrans2);
	      fflush(stdout);
	      */
	      if(p[iI] < p[iJ] && p[iJ] < p[iK]){
		if(iActualsign[iI] + iActualsign[iJ] + iActualsign[iK] == -3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      
	      if(p[iI]<p[iK]&&p[iK]<p[iJ]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}		    		      
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      }
	      if(p[iJ]<p[iI]&&p[iI]<p[iK]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==1&&iActualsign[iI]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      if(p[iJ]<p[iK]&&p[iK]<p[iI]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iI]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      if(p[iK]<p[iI]&&p[iI]<p[iJ]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}			
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iK]==-1&&iActualsign[iI]*iActualsign[iJ]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-11){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      }
	      if(p[iK]<p[iJ]&&p[iJ]<p[iI]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3)
		  {
		    iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		    iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		    iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		    iSuperGoodtrans++;
		    iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		    iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		    iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		    iGoodinvtrans1++;
		    iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		    iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		    iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		    iGoodinvtrans2++;
		  }
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iK]==1&&iActualsign[iI]*iActualsign[iJ]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];			  
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      
	      }
	    }/*iK*/
	  }/*iJ*/
	}/*iI*/
      }/*if cyclelength>2*/
      /*
      printf("t");
      fflush(stdout);
      */
    }/*if iIi...*/
  }/*while...*/
  
  
  iSumsquared=0;
  iReverseplus=0;
  for(iI = 0; iI < iNumberofcycles; iI++){
    iSumsquared+=iCyclelength[iI]*(iCyclelength[iI]-1);
    d[iI]=(iCyclelength[iI]-iNumberofplus[iI])*iNumberofplus[iI];
    iReverseplus+=d[iI];
  }
  iReverseminus=((iXX+1)*iXX-iSumsquared)/2;
  iReversesame=(iXX+1)*iXX/2-iReverseplus-iReverseminus;
  
  /* PROPOSING A NEW STEP */

  eProposal = 1.0;

  iGoodall = iGoodtrans + iGoodinvtrans1 + iGoodinvtrans2;
  iSuperGoodall = iSuperGoodtrans + iSuperGoodinvtrans1 + iSuperGoodinvtrans2;

  /* bening mutation */
  if(iGoodall + iSuperGoodall + iReverseplus > 0 && iIntrand(100) != 0){
    eProposal *= 0.99;
    /* 2-transposition */
    if(iSuperGoodall > 0 && iIntrand(100) < 50){
      eProposal *= 0.5/(double)iSuperGoodall;
      iTemp = iIntrand(iSuperGoodall);
      if(iTemp < iSuperGoodtrans){
	iTemp = iIntrand(iSuperGoodtrans);
	iI = iSuperGoodtranslist[iTemp][0];
	iJ = iSuperGoodtranslist[iTemp][1];
	iK = iSuperGoodtranslist[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Transposition(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 0;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
      else if(iTemp < iSuperGoodtrans + iSuperGoodinvtrans1){
	iTemp = iIntrand(iSuperGoodinvtrans1);
	iI = iSuperGoodinvtranslist1[iTemp][0];
	iJ = iSuperGoodinvtranslist1[iTemp][1];
	iK = iSuperGoodinvtranslist1[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition1(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 1;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
      else{
	iTemp = iIntrand(iSuperGoodinvtrans2);
	iI = iSuperGoodinvtranslist2[iTemp][0];
	iJ = iSuperGoodinvtranslist2[iTemp][1];
	iK = iSuperGoodinvtranslist2[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition2(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 2;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
    }
    /* 1-transposition or 1-inversion */
    else{
      if(iSuperGoodall != 0){
	eProposal *= 0.5;
      }
      eProposal /= (double) (iGoodall + iReverseplus);
      iTemp = iIntrand(iGoodall + iReverseplus);
      if(iTemp < iGoodtrans){
	iTemp = iIntrand(iGoodtrans);
	iI = iGoodtranslist[iTemp][0];
	iJ = iGoodtranslist[iTemp][1];
	iK = iGoodtranslist[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Transposition(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 0;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
      else if(iTemp < iGoodtrans + iGoodinvtrans1){
	iTemp = iIntrand(iGoodinvtrans1);
	iI = iGoodinvtranslist1[iTemp][0];
	iJ = iGoodinvtranslist1[iTemp][1];
	iK = iGoodinvtranslist1[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition1(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 1;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
      else if(iTemp < iGoodtrans + iGoodinvtrans1 + iGoodinvtrans2){
	iTemp = iIntrand(iGoodinvtrans2);
	iI = iGoodinvtranslist2[iTemp][0];
	iJ = iGoodinvtranslist2[iTemp][1];
	iK = iGoodinvtranslist2[iTemp][2];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	if(iI > iK){
	  Swap(&iI,&iK);
	}
	if(iJ > iK){
	  Swap(&iJ,&iK);
	}
	Invtransposition2(iPermutation,iI,iJ,iK,iXX);
	iHistory[0] = 2;
	iHistory[1] = iI;
	iHistory[2] = iJ;
	iHistory[3] = iK;
      }
      else{
	/* +1-inversion */
	iTemp = iIntrand(iKumPlus1[iNumberofcycles - 1]);
	for(iK = 0; iTemp >= iKumPlus1[iK]; iK++);
	iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
	iJ = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
	if(iI > iJ){
	  Swap(&iI,&iJ);
	}
	Reversion(iPermutation,iI,iJ,iXX);
	if(iI == iJ){
	  printf("Hey1\n");
	  scanf("%d",&iI);
	}
	iHistory[0] = 3;
	iHistory[1] = iI;
	iHistory[2] = iJ;
       }
    }
  }
  /* 0-inversion */
  else if((iReversesame > 0 && iIntrand(100) < 50) || (iReverseminus == 0 && 2 * (iGoodall + iSuperGoodall) == iXX * iXX * iXX - iXX)){
    eProposal /= (double) iReversesame;
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReverseminus != 0 || 2*(iGoodall + iSuperGoodall) != iXX * iXX * iXX - iXX){
      eProposal *= 0.5;
    }
    iTemp = iIntrand(iKum0[iNumberofcycles - 1]);
    for(iK = 0; iTemp >= iKum0[iK]; iK++);
    iTemp = iIntrand(iNumberofplus[iK] * (iNumberofplus[iK] - 1) + (iCyclelength[iK] - iNumberofplus[iK]) * (iCyclelength[iK] - iNumberofplus[iK] - 1) );
    if(iTemp < iNumberofplus[iK] * (iNumberofplus[iK] - 1)){
      iI = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
      iJ = iI;
      while(iJ == iI){
	iJ = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      Reversion(iPermutation,iI,iJ,iXX);
      if(iI == iJ){
	printf("Hey2\n");
	scanf("%d",&iI);
      }
      iHistory[0] = 3;
      iHistory[1] = iI;
      iHistory[2] = iJ;
    }
    else{
      iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
      iJ = iI;
      while(iJ == iI){
	iJ = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      Reversion(iPermutation,iI,iJ,iXX);
      if(iI == iJ){
	printf("Hey3\n");
	scanf("%d",&iI);
      }
      iHistory[0] = 3;
      iHistory[1] = iI;
      iHistory[2] = iJ;
    }
  }
  /* -1-inversion */
  else if(iReverseminus > 0 && iIntrand(100) < 80){
    eProposal = 0.8;
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReversesame > 0){
      eProposal *= 0.5;
    }
    eProposal /= (double) iReverseminus;
    /*
    iTemp = iIntrand(iKumMinus11[iNumberofcycles - 1]);
    for(iK = 0; iTemp >= iKumMinus11[iK]; iK++);
    iTemp = iIntrand(iCyclelength[iK]);
    if(iTemp < iNumberofplus[iK]){
      iI = iListofpositives[iK][iIntrand(iNumberofplus[iK])];
    }
    else{
      iI = iListofnegatives[iK][iIntrand(iCyclelength[iK] - iNumberofplus[iK])];
    }
    iJ = iI;
    while(iJ == iI){
      iTemp = iIntrand(iKumMinus12[iNumberofcycles - 1] - iKumMinus12[iK]);
      for(iL = 0; iTemp >= iKumMinus12[iL]; iL++){
	if(iL == iK - 1){
	  iTemp += iCyclelength[iK];
	}
      }
      iTemp = iIntrand(iCyclelength[iL]);
      if(iTemp < iNumberofplus[iL]){
	iJ = iListofpositives[iL][iIntrand(iNumberofplus[iL])];
      }
      else{
	iJ = iListofnegatives[iL][iIntrand(iCyclelength[iL] - iNumberofplus[iL])];
      }
    }
    if(iI > iJ){
      Swap(&iI,&iJ);
    }
    */
    iAccepted = 0;
    while(iAccepted == 0){
      iI = iIntrand(iXX + 1);
      iJ = iIntrand(iXX);
      if(iJ == iI){
	iJ++;
      }
      if(iI > iJ){
	Swap(&iI,&iJ);
      }
      if(iCyclenumber[iI] != iCyclenumber[iJ]){
	iAccepted = 1;
      }
    }
    Reversion(iPermutation,iI,iJ,iXX);
    if(iI == iJ){
      printf("Hey4\n");
      scanf("%d",&iI);
    }
    iHistory[0] = 3;
    iHistory[1] = iI;
    iHistory[2] = iJ;
  }
  /* non-benign transposition */
  else{
    if(iGoodall + iSuperGoodall + iReverseplus != 0){
      eProposal *= 0.01;
    }
    if(iReversesame > 0){
      eProposal *= 0.5;
    }
    if(iReverseminus > 0){
      eProposal *= 0.2;
    }

    /**********************************************************************************************/
    iBadtrans=((iXX+1)*iXX*(iXX-1)/6)-iGoodtrans - iSuperGoodtrans;
    iBadinvtrans1=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans1 - iSuperGoodinvtrans1;
    iBadinvtrans2=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans2 - iSuperGoodinvtrans2;
    
    iAccepted=0;
    if(iIntrand(iBadtrans+iBadinvtrans1+iBadinvtrans2)<iBadtrans){
      while(iAccepted==0){
	/* transposition */
	iI=iIntrand(iXX+1);
	iJ=iIntrand(iXX);
	if(iJ>=iI){
	  iJ++;
	}
	else{
	  Swap(&iI,&iJ);
	}
	iK=iIntrand(iXX-1);
	if(iK>=iI)
	  iK++;
	if(iK>=iJ)
	  iK++;
	if(iK<iI){
	  Swap(&iK,&iI);
	  Swap(&iK,&iJ);
	}
	if(iK<iJ){
	  Swap(&iK,&iJ);
	}	  
	iAccepted=1;
	for(iTemp=0;iTemp<iGoodtrans;iTemp++){
	  if(iI==iGoodtranslist[iTemp][0]&&iJ==iGoodtranslist[iTemp][1]&&iK==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iI==iGoodtranslist[iTemp][0]&&iK==iGoodtranslist[iTemp][1]&&iJ==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodtranslist[iTemp][0]&&iI==iGoodtranslist[iTemp][1]&&iK==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodtranslist[iTemp][0]&&iK==iGoodtranslist[iTemp][1]&&iI==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodtranslist[iTemp][0]&&iI==iGoodtranslist[iTemp][1]&&iJ==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodtranslist[iTemp][0]&&iJ==iGoodtranslist[iTemp][1]&&iI==iGoodtranslist[iTemp][2])
	    iAccepted=0;
	}
	for(iTemp=0;iTemp<iSuperGoodtrans;iTemp++){
	  if(iI==iSuperGoodtranslist[iTemp][0]&&iJ==iSuperGoodtranslist[iTemp][1]&&iK==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iI==iSuperGoodtranslist[iTemp][0]&&iK==iSuperGoodtranslist[iTemp][1]&&iJ==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodtranslist[iTemp][0]&&iI==iSuperGoodtranslist[iTemp][1]&&iK==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodtranslist[iTemp][0]&&iK==iSuperGoodtranslist[iTemp][1]&&iI==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodtranslist[iTemp][0]&&iI==iSuperGoodtranslist[iTemp][1]&&iJ==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodtranslist[iTemp][0]&&iJ==iSuperGoodtranslist[iTemp][1]&&iI==iSuperGoodtranslist[iTemp][2])
	    iAccepted=0;
	}
	if(iAccepted==1){
	  Transposition(iPermutation,iI,iJ,iK,iXX);
	  iHistory[0] = 0;
	  iHistory[1] = iI;
	  iHistory[2] = iJ;
	  iHistory[3] = iK;
	  /* printf("transposition, %d, %d, %d\n",i,iJ,iK);*/
	    eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	}
      }
    }
    else if(iIntrand(iBadinvtrans1+iBadinvtrans2)<iBadinvtrans1){
      while(iAccepted==0){
	/* invtransposition1 */
	iI=iIntrand(iXX+1);
	iJ=iIntrand(iXX);
	if(iJ>=iI){
	  iJ++;
	}
	else{
	  Swap(&iI,&iJ);
	}
	iK=iIntrand(iXX-1);
	if(iK>=iI){
	  iK++;
	}
	if(iK>=iJ){
	  iK++;
	}
	if(iK<iI){
	  Swap(&iI,&iK);
	  Swap(&iJ,&iK);
	}
	if(iK<iJ){
	  Swap(&iJ,&iK);
	}	  
	iAccepted=1;
	for(iTemp=0;iTemp<iGoodinvtrans1;iTemp++){
	  if(iI==iGoodinvtranslist1[iTemp][0]&&iJ==iGoodinvtranslist1[iTemp][1]&&iK==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iI==iGoodinvtranslist1[iTemp][0]&&iK==iGoodinvtranslist1[iTemp][1]&&iJ==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist1[iTemp][0]&&iI==iGoodinvtranslist1[iTemp][1]&&iK==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist1[iTemp][0]&&iK==iGoodinvtranslist1[iTemp][1]&&iI==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist1[iTemp][0]&&iI==iGoodinvtranslist1[iTemp][1]&&iJ==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist1[iTemp][0]&&iJ==iGoodinvtranslist1[iTemp][1]&&iI==iGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	}
	for(iTemp=0;iTemp<iSuperGoodinvtrans1;iTemp++){
	  if(iI==iSuperGoodinvtranslist1[iTemp][0]&&iJ==iSuperGoodinvtranslist1[iTemp][1]&&iK==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iI==iSuperGoodinvtranslist1[iTemp][0]&&iK==iSuperGoodinvtranslist1[iTemp][1]&&iJ==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist1[iTemp][0]&&iI==iSuperGoodinvtranslist1[iTemp][1]&&iK==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist1[iTemp][0]&&iK==iSuperGoodinvtranslist1[iTemp][1]&&iI==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist1[iTemp][0]&&iI==iSuperGoodinvtranslist1[iTemp][1]&&iJ==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist1[iTemp][0]&&iJ==iSuperGoodinvtranslist1[iTemp][1]&&iI==iSuperGoodinvtranslist1[iTemp][2])
	    iAccepted=0;
	}
	if(iAccepted==1){
	  Invtransposition1(iPermutation,iI,iJ,iK,iXX);
	  iHistory[0] = 1;
	  iHistory[1] = iI;
	  iHistory[2] = iJ;
	  iHistory[3] = iK;
	  /* printf("invtransposition1, %d, %d, %d\n",i,iJ,iK);*/
	  eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	}
      }
    }
    else{
      while(iAccepted==0){
	iI=iIntrand(iXX+1);
	iJ=iIntrand(iXX);
	if(iJ>=iI){
	  iJ++;
	}
	else{
	  Swap(&iI,&iJ);
	}
	iK=iIntrand(iXX-1);
	if(iK>=iI){
	  iK++;
	}
	if(iK>=iJ){
	  iK++;
	}
	if(iK<iI){
	  Swap(&iI,&iK);
	  Swap(&iJ,&iK);
	}
	if(iK<iJ){
	  Swap(&iJ,&iK);
	}	  	
	iAccepted=1;
	for(iTemp=0;iTemp<iGoodinvtrans2;iTemp++){
	  if(iI==iGoodinvtranslist2[iTemp][0]&&iJ==iGoodinvtranslist2[iTemp][1]&&iK==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iI==iGoodinvtranslist2[iTemp][0]&&iK==iGoodinvtranslist2[iTemp][1]&&iJ==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist2[iTemp][0]&&iI==iGoodinvtranslist2[iTemp][1]&&iK==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iGoodinvtranslist2[iTemp][0]&&iK==iGoodinvtranslist2[iTemp][1]&&iI==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist2[iTemp][0]&&iI==iGoodinvtranslist2[iTemp][1]&&iJ==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iGoodinvtranslist2[iTemp][0]&&iJ==iGoodinvtranslist2[iTemp][1]&&iI==iGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	}
	for(iTemp=0;iTemp<iSuperGoodinvtrans2;iTemp++){
	  if(iI==iSuperGoodinvtranslist2[iTemp][0]&&iJ==iSuperGoodinvtranslist2[iTemp][1]&&iK==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iI==iSuperGoodinvtranslist2[iTemp][0]&&iK==iSuperGoodinvtranslist2[iTemp][1]&&iJ==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist2[iTemp][0]&&iI==iSuperGoodinvtranslist2[iTemp][1]&&iK==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iJ==iSuperGoodinvtranslist2[iTemp][0]&&iK==iSuperGoodinvtranslist2[iTemp][1]&&iI==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist2[iTemp][0]&&iI==iSuperGoodinvtranslist2[iTemp][1]&&iJ==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	  if(iK==iSuperGoodinvtranslist2[iTemp][0]&&iJ==iSuperGoodinvtranslist2[iTemp][1]&&iI==iSuperGoodinvtranslist2[iTemp][2])
	    iAccepted=0;
	}
	if(iAccepted==1){
	  Invtransposition2(iPermutation,iI,iJ,iK,iXX);
	  iHistory[0] = 2;
	  iHistory[1] = iI;
	  iHistory[2] = iJ;
	  iHistory[3] = iK;
	  /*		  printf("invtransposition2, %d, %d, %d\n",i,iJ,iK);*/
	  eProposal *= 1.0/(double)(iBadtrans+iBadinvtrans1+iBadinvtrans2);
	}
      }
    }
    /**********************************************************************************************/
  }

  
  return(eProposal);
}

double eProposalstep(int iPermutation[2 * XX + 2],
	             int iHistory[4],
		     int iXX){

  int iIntrand();
  void Reversion(int[2 * XX + 2],
		 int,
		 int,
		 int);
  void Transposition(int[2 * XX + 2],
		     int,
		     int,
		     int,
		     int);
  void Invtransposition1(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void Invtransposition2(int[2 * XX + 2],
			 int,
			 int,
			 int,
			 int);
  void Swap();
  int iInvpermutation[2*XX+2];
  int iI, iIi, iJ, iK;
  int iNumberofcycles, iCyclelength[XX+2], iNumberofplus[XX+2], iSign[XX+2], iCyclenumber[XX+2],iTraversed[2*XX+2];
  int p[XX+2], iActualsign[XX+2];
  int iSumsquared, d[XX+2];
  long int iReverseplus, iReverseminus, iReversesame;
  long int iGoodtrans, iGoodinvtrans1, iGoodinvtrans2, iLongTemp;
  long int iBadtrans, iBadinvtrans1, iBadinvtrans2;
  extern int **iGoodtranslist, **iGoodinvtranslist1, **iGoodinvtranslist2;
  long int iSuperGoodtrans, iSuperGoodinvtrans1, iSuperGoodinvtrans2;
  extern int **iSuperGoodtranslist, **iSuperGoodinvtranslist1, **iSuperGoodinvtranslist2;
  int iAccepted;
  double eProposal;
  int iGoodall, iSuperGoodall;
  int iSam;

  extern int *iKum0, *iKumPlus1, *iKumMinus11, *iKumMinus12;
  extern int **iListofpositives, **iListofnegatives;

  iLongTemp = ((long int)iXX*(iXX + 1)*(iXX - 1)/6 < 1000000L)?(long int)iXX*(iXX + 1)*(iXX - 1)/6:1000000L;


  /* INVERSE PERMUTATION */

  for(iI = 0; iI < 2 * iXX + 2; iI++){
    iInvpermutation[iPermutation[iI]] = iI;
    iTraversed[iI]=0;
  }

  /* DECOMPOSITION TO CYCLES */

  iNumberofcycles=0;
  iIi=0;
  iKum0[0] = 0;
  iKumPlus1[0] = 0;
  iKumMinus11[0] = 0;
  iKumMinus12[0] = 0;
 
  iSam = 0;
  iGoodtrans=0;
  iGoodinvtrans1=0;
  iGoodinvtrans2=0;
  iSuperGoodtrans=0;
  iSuperGoodinvtrans1=0;
  iSuperGoodinvtrans2=0;
  
  while(iIi < 2 * iXX + 2){
    
    /* finding the begining of the cycle */
    
    
    while(iTraversed[iIi] == 1 && iIi < 2 * iXX + 2){
      iIi++;
    }
    
    
    /* traversing the new cycle*/
    
    if(iIi < 2 * iXX + 2){
      iNumberofcycles++;
      iCyclelength[iNumberofcycles - 1] = 0;
      iNumberofplus[iNumberofcycles - 1] = 0;
      iJ = iIi;
    
      while(iTraversed[iJ] == 0){
	iTraversed[iJ] = 1;
	iCyclelength[iNumberofcycles - 1]++;
	
	/* finding the next black edge */
	
	if(iJ / 2 == (iJ + 1) / 2){
	  iSign[iJ / 2] = 1;
	  iCyclenumber[iJ / 2] = iNumberofcycles;
	  iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = 1;
	  p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	  iNumberofplus[iNumberofcycles - 1]++;
	  iListofpositives[iNumberofcycles -1][iNumberofplus[iNumberofcycles - 1] - 1] = iJ / 2;
	  iJ++;
	  iTraversed[iJ] = 1;
	}
	else{
	  iJ--;
	  iSign[iJ / 2] = -1;
	  iCyclenumber[iJ / 2] = iNumberofcycles;
	  iActualsign[iCyclelength[iNumberofcycles - 1] - 1] = -1;
	  p[iCyclelength[iNumberofcycles - 1] - 1] = iJ / 2;
	  iListofnegatives[iNumberofcycles -1][iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1]-1] = iJ / 2;
	  iTraversed[iJ] = 1;
	}
	if(iPermutation[iJ] / 2 == (iPermutation[iJ] + 1) / 2 ){
	  iJ = iInvpermutation[iPermutation[iJ] + 1];
	}
	else{
	  iJ = iInvpermutation[iPermutation[iJ] - 1];
	}
	
      }
      
      /* Obtaining the kumulative functions */ 
      
      iKum0[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iNumberofplus[iNumberofcycles - 1] - 1) + (iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1])*(iCyclelength[iNumberofcycles - 1] - iNumberofplus[iNumberofcycles - 1] - 1);
      iKumPlus1[iNumberofcycles - 1] = iNumberofplus[iNumberofcycles - 1]*(iCyclelength[iNumberofcycles - 1] -iNumberofplus[iNumberofcycles - 1]);
      iKumMinus11[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1]*(iXX + 1 - iCyclelength[iNumberofcycles - 1]);
      iKumMinus12[iNumberofcycles - 1] = iCyclelength[iNumberofcycles - 1];
      if(iNumberofcycles > 1){
	iKum0[iNumberofcycles - 1] += iKum0[iNumberofcycles - 2];
	iKumPlus1[iNumberofcycles - 1] += iKumPlus1[iNumberofcycles - 2];
	iKumMinus11[iNumberofcycles - 1] += iKumMinus11[iNumberofcycles - 2];
	iKumMinus12[iNumberofcycles - 1] += iKumMinus12[iNumberofcycles - 2];
      }
      
      /* investigating long cycles */
      if(iCyclelength[iNumberofcycles - 1] > 2){
	for(iI = 0; iI < iCyclelength[iNumberofcycles - 1] - 2; iI++){
	  for(iJ = iI + 1; iJ < iCyclelength[iNumberofcycles - 1] - 1; iJ++){
	    for(iK = iJ + 1; iK < iCyclelength[iNumberofcycles - 1]; iK++){
	      iSam++;

	      if(iGoodtrans >= iLongTemp){
		iGoodtrans--;
	      }
	      if(iGoodinvtrans1 >= iLongTemp){
		iGoodinvtrans1--;
	      }
	      if(iGoodinvtrans2 >= iLongTemp){
		iGoodinvtrans2--;
	      }
	      if(iSuperGoodtrans >= iLongTemp){
		iSuperGoodtrans--;
	      }
	      if(iSuperGoodinvtrans1 >= iLongTemp){
		iSuperGoodinvtrans1--;
	      }
	      if(iSuperGoodinvtrans2 >= iLongTemp){
		iSuperGoodinvtrans2--;
	      }

	      if(p[iI] < p[iJ] && p[iJ] < p[iK]){
		if(iActualsign[iI] + iActualsign[iJ] + iActualsign[iK] == -3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      
	      if(p[iI]<p[iK]&&p[iK]<p[iJ]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}		    		      
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      }
	      if(p[iJ]<p[iI]&&p[iI]<p[iK]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==1&&iActualsign[iI]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==-1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      if(p[iJ]<p[iK]&&p[iK]<p[iI]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iI]*iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==1&&iActualsign[iJ]==-1&&iActualsign[iK]==-1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		
	      }
	      if(p[iK]<p[iI]&&p[iI]<p[iJ]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==-3){
		  iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		  iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		  iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		  iSuperGoodtrans++;
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}			
		
		if(iActualsign[iI]==-1&&iActualsign[iJ]==-1&&iActualsign[iK]==1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iK]==-1&&iActualsign[iI]*iActualsign[iJ]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iJ]==-1&&iActualsign[iK]==1&&iActualsign[iI]==-1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iJ]==1&&iActualsign[iK]==-1&&iActualsign[iI]==-11){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      }
	      if(p[iK]<p[iJ]&&p[iJ]<p[iI]){
		if(iActualsign[iI]+iActualsign[iJ]+iActualsign[iK]==3)
		  {
		    iSuperGoodtranslist[iSuperGoodtrans][0] = p[iI];
		    iSuperGoodtranslist[iSuperGoodtrans][1] = p[iJ];
		    iSuperGoodtranslist[iSuperGoodtrans][2] = p[iK];
		    iSuperGoodtrans++;
		    iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		    iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		    iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		    iGoodinvtrans1++;
		    iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		    iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		    iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		    iGoodinvtrans2++;
		  }
		
		if(iActualsign[iI]==1&&iActualsign[iJ]==1&&iActualsign[iK]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iK]==1&&iActualsign[iI]*iActualsign[iJ]==-1){
		  iGoodtranslist[iGoodtrans][0] = p[iI];
		  iGoodtranslist[iGoodtrans][1] = p[iJ];
		  iGoodtranslist[iGoodtrans][2] = p[iK];
		  iGoodtrans++;
		}
		
		if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==-1){
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
		if(iActualsign[iI]==1&&iActualsign[iK]==-1&&iActualsign[iJ]==1){
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][0] = p[iI];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][1] = p[iJ];
		  iSuperGoodinvtranslist2[iSuperGoodinvtrans2][2] = p[iK];
		  iSuperGoodinvtrans2++;
		}
		
		
		if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==-1){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		}
		if(iActualsign[iI]==-1&&iActualsign[iK]==1&&iActualsign[iJ]==1){
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][0] = p[iI];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][1] = p[iJ];
		  iSuperGoodinvtranslist1[iSuperGoodinvtrans1][2] = p[iK];
		  iSuperGoodinvtrans1++;
		}
		
		if((iActualsign[iI]==-1) && (iActualsign[iJ]==1) && (iActualsign[iK]==-1)){
		  iGoodinvtranslist1[iGoodinvtrans1][0] = p[iI];
		  iGoodinvtranslist1[iGoodinvtrans1][1] = p[iJ];
		  iGoodinvtranslist1[iGoodinvtrans1][2] = p[iK];
		  iGoodinvtrans1++;
		  iGoodinvtranslist2[iGoodinvtrans2][0] = p[iI];			  
		  iGoodinvtranslist2[iGoodinvtrans2][1] = p[iJ];
		  iGoodinvtranslist2[iGoodinvtrans2][2] = p[iK];
		  iGoodinvtrans2++;
		}
	      
	      }
	    }/*iK*/
	  }/*iJ*/
	}/*iI*/
      }/*if cyclelength>2*/
    }/*if iIi...*/
  }/*while*/


  
  
  iSumsquared=0;
  iReverseplus=0;
  for(iI = 0; iI < iNumberofcycles; iI++){
    iSumsquared+=iCyclelength[iI]*(iCyclelength[iI]-1);
    d[iI]=(iCyclelength[iI]-iNumberofplus[iI])*iNumberofplus[iI];
    iReverseplus+=d[iI];
  }
  iReverseminus=((iXX+1)*iXX-iSumsquared)/2;
  iReversesame=(iXX+1)*iXX/2-iReverseplus-iReverseminus;
  iGoodall = iGoodtrans + iGoodinvtrans1 + iGoodinvtrans2;
  iSuperGoodall = iSuperGoodtrans + iSuperGoodinvtrans1 + iSuperGoodinvtrans2;
  iBadtrans=((iXX+1)*iXX*(iXX-1)/6)-iGoodtrans - iSuperGoodtrans;
  iBadinvtrans1=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans1 - iSuperGoodinvtrans1;
  iBadinvtrans2=((iXX+1)*iXX*(iXX-1)/6)-iGoodinvtrans2 - iSuperGoodinvtrans2;
  
  /* Calculating the proposal probability */
  if(iHistory[0] == 0){
    /* Transposition */
    /* supergood transposition */
    iAccepted = 0;
    for(iI = 0; iI < iSuperGoodtrans; iI++){
      if(iHistory[1] == iSuperGoodtranslist[iI][0] && 
	 iHistory[2] == iSuperGoodtranslist[iI][1] &&
	 iHistory[3] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[1] == iSuperGoodtranslist[iI][0] && 
	 iHistory[3] == iSuperGoodtranslist[iI][1] &&
	 iHistory[2] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodtranslist[iI][0] && 
	 iHistory[1] == iSuperGoodtranslist[iI][1] &&
	 iHistory[3] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodtranslist[iI][0] && 
	 iHistory[3] == iSuperGoodtranslist[iI][1] &&
	 iHistory[1] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodtranslist[iI][0] && 
	 iHistory[1] == iSuperGoodtranslist[iI][1] &&
	 iHistory[2] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodtranslist[iI][0] && 
	 iHistory[2] == iSuperGoodtranslist[iI][1] &&
	 iHistory[1] == iSuperGoodtranslist[iI][2]){
	iAccepted = 1;
      }
    }
    if(iAccepted == 1){
      eProposal = 0.99 * 0.5 / (double) iSuperGoodall;
      /*      printf("iSuperGoodall trans\n");*/
      if(iSuperGoodall == 0){
	printf("iSuperGoodall == 0\n");
	scanf("%d",&iI);
      }
    }
    else{
      /* good transposition */
      iAccepted = 0;
      for(iI = 0; iI < iGoodtrans; iI++){
	if(iHistory[1] == iGoodtranslist[iI][0] && 
	   iHistory[2] == iGoodtranslist[iI][1] &&
	   iHistory[3] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[1] == iGoodtranslist[iI][0] && 
	   iHistory[3] == iGoodtranslist[iI][1] &&
	   iHistory[2] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[2] == iGoodtranslist[iI][0] && 
	   iHistory[1] == iGoodtranslist[iI][1] &&
	   iHistory[3] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[2] == iGoodtranslist[iI][0] && 
	   iHistory[3] == iGoodtranslist[iI][1] &&
	   iHistory[1] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodtranslist[iI][0] && 
	   iHistory[1] == iGoodtranslist[iI][1] &&
	   iHistory[2] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodtranslist[iI][0] && 
	   iHistory[2] == iGoodtranslist[iI][1] &&
	   iHistory[1] == iGoodtranslist[iI][2]){
	  iAccepted = 1;
	}	
      }
      if(iAccepted == 1){
	eProposal = 0.99 / (double) (iGoodall + iReverseplus);
	/*	printf("iGoodall trans\n");*/
	if(iGoodall == 0){
	  printf("iGoodall == 0\n");
	  scanf("%d",&iI);
	}
	if(iSuperGoodall > 0){
	  eProposal *= 0.5;
	}
      }
      else{
	/* non-benign transposition */
	eProposal = 1.0 / (double)(iBadtrans + iBadinvtrans1 + iBadinvtrans2);
	/*	printf("iBad trans\n");*/
	if(iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0){
	  for(iI = 0; iI < 2 * iXX + 2; iI++){
	    printf("%d ",iPermutation[iI]);
	  }
	  printf("\n");
	  printf("%d %d %d\n",iHistory[1],iHistory[2],iHistory[3]);
	  printf("iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0\n");
	  printf("Trans: %ld Invtrans1: %ld, Invtrans2: %ld iSam: %d\n",iGoodtrans + iSuperGoodtrans,iGoodinvtrans1 + iSuperGoodinvtrans1,
		 iGoodinvtrans2 + iSuperGoodinvtrans2,iSam);
	  scanf("%d",&iI);
	}
	if(iGoodall + iSuperGoodall + iReverseplus != 0){
	  eProposal *= 0.01;
	}
	if(iReversesame > 0){
	  eProposal *= 0.5;
	}
	if(iReverseminus > 0){
	  eProposal *= 0.2;
	}
      }
    }
    Transposition(iPermutation,iHistory[1],iHistory[2],iHistory[3],iXX);
  }
  else if(iHistory[0] == 1){
    /* Invransposition1 */
    /* supergood invtransposition1 */
    iAccepted = 0;
    for(iI = 0; iI < iSuperGoodinvtrans1; iI++){
      if(iHistory[1] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[2] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[3] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[1] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[3] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[2] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[1] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[3] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[3] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[1] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[1] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[2] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodinvtranslist1[iI][0] && 
	 iHistory[2] == iSuperGoodinvtranslist1[iI][1] &&
	 iHistory[1] == iSuperGoodinvtranslist1[iI][2]){
	iAccepted = 1;
      }
    }
    if(iAccepted == 1){
      /*      printf("iSuperGoodall inv1\n");*/
      eProposal = 0.99 * 0.5 / (double)iSuperGoodall;
      if(iSuperGoodall == 0){
	printf("iSuperGoodall == 0\n");
	scanf("%d",&iI);
      }
    }
    else{
      /* good invtransposition1 */
      iAccepted = 0;
      for(iI = 0; iI < iGoodinvtrans1; iI++){
	if(iHistory[1] == iGoodinvtranslist1[iI][0] && 
	   iHistory[2] == iGoodinvtranslist1[iI][1] &&
	   iHistory[3] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[1] == iGoodinvtranslist1[iI][0] && 
	   iHistory[3] == iGoodinvtranslist1[iI][1] &&
	   iHistory[2] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
 	if(iHistory[2] == iGoodinvtranslist1[iI][0] && 
	   iHistory[1] == iGoodinvtranslist1[iI][1] &&
	   iHistory[3] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[2] == iGoodinvtranslist1[iI][0] && 
	   iHistory[3] == iGoodinvtranslist1[iI][1] &&
	   iHistory[1] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodinvtranslist1[iI][0] && 
	   iHistory[1] == iGoodinvtranslist1[iI][1] &&
	   iHistory[2] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodinvtranslist1[iI][0] && 
	   iHistory[2] == iGoodinvtranslist1[iI][1] &&
	   iHistory[1] == iGoodinvtranslist1[iI][2]){
	  iAccepted = 1;
	}	
     }
      if(iAccepted == 1){
	/*	printf("iGoodall inv1\n");*/
	eProposal =0.99 / (double)(iGoodall + iReverseplus);
	if(iGoodall == 0){
	  printf("iGoodall == 0\n");
	  scanf("%d",&iI);
	}
	if(iSuperGoodall > 0){
	  eProposal *= 0.5;
	}
      }
      else{
	/* non-benign invtransposition1 */
	/*	printf("iBad inv1\n");*/
	eProposal = 1.0 / (double)(iBadtrans + iBadinvtrans1 + iBadinvtrans2);
	if(iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0){
	  printf("iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0\n");
	  scanf("%d",&iI);
	}
  	if(iGoodall + iSuperGoodall + iReverseplus != 0){
	  eProposal *= 0.01;
	}
	if(iReversesame > 0){
	  eProposal *= 0.5;
	}
	if(iReverseminus > 0){
	  eProposal *= 0.2;
	}
      }
    }
    Invtransposition1(iPermutation,iHistory[1],iHistory[2],iHistory[3],iXX);
  }
  else if(iHistory[0] == 2){
    /* Invransposition2 */
    /* supergood invtransposition2 */
    iAccepted = 0;
    for(iI = 0; iI < iSuperGoodinvtrans2; iI++){
      if(iHistory[1] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[2] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[3] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[1] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[3] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[2] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[1] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[3] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[2] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[3] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[1] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[1] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[2] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
      if(iHistory[3] == iSuperGoodinvtranslist2[iI][0] && 
	 iHistory[2] == iSuperGoodinvtranslist2[iI][1] &&
	 iHistory[1] == iSuperGoodinvtranslist2[iI][2]){
	iAccepted = 1;
      }
   }
    if(iAccepted == 1){
      /*      printf("iSuperGoodall inv2\n");*/
      eProposal = 0.99 * 0.5 /(double) iSuperGoodall;
      if(iSuperGoodall == 0){
	printf("iSuperGoodall == 0\n");
	scanf("%d",&iI);
      }
    }
    else{
      /* good invtransposition2 */
      iAccepted = 0;
      for(iI = 0; iI < iGoodinvtrans2; iI++){
	if(iHistory[1] == iGoodinvtranslist2[iI][0] && 
	   iHistory[2] == iGoodinvtranslist2[iI][1] &&
	   iHistory[3] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[1] == iGoodinvtranslist2[iI][0] && 
	   iHistory[3] == iGoodinvtranslist2[iI][1] &&
	   iHistory[2] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
 	if(iHistory[2] == iGoodinvtranslist2[iI][0] && 
	   iHistory[1] == iGoodinvtranslist2[iI][1] &&
	   iHistory[3] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[2] == iGoodinvtranslist2[iI][0] && 
	   iHistory[3] == iGoodinvtranslist2[iI][1] &&
	   iHistory[1] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodinvtranslist2[iI][0] && 
	   iHistory[1] == iGoodinvtranslist2[iI][1] &&
	   iHistory[2] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
	if(iHistory[3] == iGoodinvtranslist2[iI][0] && 
	   iHistory[2] == iGoodinvtranslist2[iI][1] &&
	   iHistory[1] == iGoodinvtranslist2[iI][2]){
	  iAccepted = 1;
	}	
     }
      if(iAccepted == 1){
	/*printf("iGoodall inv2\n");*/
	eProposal =0.99 /(double)(iGoodall + iReverseplus);
	if(iGoodall == 0){
	  printf("iGoodall == 0\n");
	  scanf("%d",&iI);
	}
	if(iSuperGoodall > 0){
	  eProposal *= 0.5;
	}
      }
      else{
	/* non-benign invtransposition2 */
	/*	printf("iBad inv2\n");*/
	eProposal = 1.0 / (double)(iBadtrans + iBadinvtrans1 + iBadinvtrans2);
	if(iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0){
	  printf("iBadtrans + iBadinvtrans1 + iBadinvtrans2 == 0\n");
	  scanf("%d",&iI);
	}
	if(iGoodall + iSuperGoodall + iReverseplus != 0){
	  eProposal *= 0.01;
	}
	if(iReversesame > 0){
	  eProposal *= 0.5;
	}
	if(iReverseminus > 0){
	  eProposal *= 0.2;
	}
      }
    }
    Invtransposition2(iPermutation,iHistory[1],iHistory[2],iHistory[3],iXX);
  }
  else{
    /* Reversion */
    if(iCyclenumber[iHistory[1]] != iCyclenumber[iHistory[2]]){
      /* -1 reversion */
      eProposal = 0.8 / (double) iReverseminus;
      /*      printf("iReverseminus\n");*/
      if(iReverseminus == 0){
	printf("iReverseminus == 0\n");
	scanf("%d",&iI);
      }
      if(iReversesame > 0){
	eProposal *= 0.5;
      }
      if(iSuperGoodall + iGoodall + iReverseplus > 0){
	eProposal *= 0.01;
      }
    }
    else if(iSign[iHistory[1]] != iSign[iHistory[2]]){
      /* +1-reversion */
      /*      printf("iReverseplus\n");*/
      eProposal = 0.99 / (double)(iGoodall + iReverseplus);
      if(iSuperGoodall > 0){
	eProposal *= 0.5;
      }
    }
    else{
      /* 0-inversion */
      if(iSuperGoodall + iGoodall + iReverseplus > 0){
	eProposal = 0.01 /(double) iReversesame;
	/*	printf("iReversame\n");*/
	if(iReversesame == 0){
	  printf("iReversame == 0\n");
	  for(iI = 0; iI < 2 * iXX + 2; iI++){
	    printf("%d ",iPermutation[iI]);
	  }
	  printf("\n");
	  printf("i: %d j: %d\n",iHistory[1],iHistory[2]);
	  scanf("%d",&iI);
	}
     }
      else{
	eProposal = 1.0 /(double) iReversesame;
	if(iReversesame == 0){
	  /*printf("iReversame == 0\n");*/
	  for(iI = 0; iI < 2 * iXX + 2; iI++){
	    printf("%d ",iPermutation[iI]);
	  }
	  printf("\n");
	  printf("i: %d j: %d\n",iHistory[1],iHistory[2]);
	  scanf("%d",&iI);
	}
      }
      if(iReverseminus + iBadtrans + iBadinvtrans1 + iBadinvtrans2 > 0){
	eProposal *= 0.5;
      }
    }
    Reversion(iPermutation,iHistory[1],iHistory[2],iXX);
  }

  return(eProposal);
}


void Reversion(int iPermutation[2 * XX + 2],
	       int iI,
	       int iJ,
	       int iXX){

  int iK,iTempperm[2 * XX + 2];

  /*  printf("Reversal!! %d %d\n",iI,iJ);*/
  for(iK = 2 * iI + 1; iK < 2 * iJ + 1; iK++){
    iTempperm[iK] = iPermutation[2 * iJ + 2 * iI + 1 - iK];
  }
  for(iK = 2 * iI + 1; iK < 2 * iJ + 1; iK++){
    iPermutation[iK]=iTempperm[iK];
  }
}

void Transposition(int iPermutation[2 * XX + 2],
		   int iI,
		   int iJ,
		   int iK,
		   int iXX){

  int iTemp, iTempperm[2 * XX + 2];

  /*  printf("Transposition!! %d %d %d\n",iI,iJ,iK);*/
  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }

}


void Invtransposition1(int iPermutation[2 * XX + 2],
		       int iI,
		       int iJ,
		       int iK,
		       int iXX){

  int iTemp, iTempperm[2 * XX + 2];

  /*  printf("Invtransposition1!! %d %d %d\n",iI,iJ,iK);*/
  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[2 * iJ + 2 * iI + 1 - iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }

}

void Invtransposition2(int iPermutation[2 * XX + 2],
		       int iI,
		       int iJ,
		       int iK,
		       int iXX){

  int iTemp, iTempperm[2 * XX + 2];
	
  /*  printf("Invtransposition2!! %d %d %d\n",iI,iJ,iK);*/
  for(iTemp = 2 * iI + 1; iTemp < 2 * iJ + 1; iTemp++){
    iTempperm[2 * iK + iTemp - 2 * iJ] = iPermutation[iTemp];
  }
  for(iTemp = 2 * iJ + 1; iTemp < 2 * iK + 1; iTemp++){
    iTempperm[2 * iI + iTemp - 2 * iJ] = iPermutation[2 * iK + 2 * iJ + 1 - iTemp];
  }
  for(iTemp = 2 * iI + 1; iTemp < 2 * iK + 1; iTemp++){
    iPermutation[iTemp] = iTempperm[iTemp];
  }
}

void BreakpointStatistics(int iPermutation[2 * XX + 2],
			  int iB1,
			  int iB2,
			  int iB3,
			  int** iBreakpoint,
			  int iXX){
  /* iB1 */
  if(iB1 > 0){
    if(iPermutation[2 * iB1] % 2 == 0){
      iBreakpoint[1][iPermutation[2 * iB1]/2 - 1]++;
    }
    else{
      iBreakpoint[0][iPermutation[2 * iB1]/2]++;
    }
  }
  if(iPermutation[2 * iB1 + 1] % 2 == 0){
    iBreakpoint[1][iPermutation[2 * iB1 + 1]/2 - 1]++;
  }
  else{
    iBreakpoint[0][iPermutation[2 * iB1 + 1]/2]++;
  }
  /* iB2 */
  if(iPermutation[2 * iB2] % 2 == 0){
    iBreakpoint[1][iPermutation[2 * iB2]/2 - 1]++;
  }
  else{
    iBreakpoint[0][iPermutation[2 * iB2]/2]++;
  }
  if(iPermutation[2 * iB2 + 1] % 2 == 0){
    iBreakpoint[1][iPermutation[2 * iB2 + 1]/2 - 1]++;
  }
  else{
    iBreakpoint[0][iPermutation[2 * iB2 + 1]/2]++;
  }
  /* iB3 */
  if(iPermutation[2 * iB3] % 2 == 0){
    iBreakpoint[1][iPermutation[2 * iB3]/2 - 1]++;
  }
  else{
    iBreakpoint[0][iPermutation[2 * iB3]/2]++;
  }
  if(iB3 < iXX){
    if(iPermutation[2 * iB3 + 1] % 2 == 0){
      iBreakpoint[1][iPermutation[2 * iB3 + 1]/2 - 1]++;
    }
    else{
      iBreakpoint[0][iPermutation[2 * iB3 + 1]/2]++;
    }
  }
  
}

int iIntrand(int iN){

  double eZ;
  long int rand();

/* pac */
#ifdef _PLAN9
  eZ = (double)rand() * (double)iN / (double)RAND_MAX;
#else
  eZ = (double)rand() * (double)iN / (double)RAND_MAX;
#endif
  if(eZ >= iN)
    eZ = iN - 1;
  if(eZ < 0)
    eZ = 0;
  return((int)floor(eZ));
}

int iMin(int iI,
	 int iJ){
  
  return(iI<iJ?iI:iJ);

}

void Swap(int *iI, int *iJ){

  int iK;

  iK = *iI;
  *iI = *iJ;
  *iJ = iK;
}

int iTest(char *c1,
	  char *c2){

  int iI,iJ;

  iI = 0;
  iJ = 1;
  while(c1[iI] != '\0' && c2[iI] != '\0'){
    if(c1[iI] != c2[iI]){
      iJ = 0;
    }
    iI++;
  }
    if(c1[iI] != c2[iI]){
      iJ = 0;
    }

    return(iJ);

}

void Min2from3(int iX,
		int iY,
		int iZ,
		int *iOut1,
		int *iOut2){

  *iOut1 = iX<iY ? iX : iY;
  *iOut2 = iX>iY ? iX : iY;
  *iOut2 = *iOut2<iZ ? *iOut2 : iZ;
}
