#include<stdio.h>
#include<math.h>
#include <stdlib.h>

int main(int iArgc, char** cArg){

  FILE *fOutput, *fInput;
  char cNameOut[255], cNameInput[255];
  int  iI, iJ, iImax;
  long int iBegin, iEnd;
  double *eStat;
  double eMax, eMin, eFontsc;
  long int iMin, iMax, iZstep;
  char cTemp[30];

  if(iArgc >= 2){
    sscanf(cArg[1],"%s",cNameInput);
  }
  else{
    sscanf("likelihood.txt","%s",cNameInput);
  }
  fInput = fopen(cNameInput,"r");
  
  if(iArgc >= 3){
    sscanf(cArg[2],"%s",cNameOut);
  }
  else{
    sscanf("default.ps","%s",cNameOut);
  }
  fOutput = fopen(cNameOut,"w");
 
  /* Reading begin */
  
  if(iArgc >= 4){
    sscanf(cArg[3],"%ld",&iBegin);
  }
  else{
    iBegin = 0;
  }
  if(iBegin < 0){
    iBegin = 0;
  }

  /* Reading input */
  fscanf(fInput,"%d",&iImax);
  eStat = (double*) malloc(sizeof(double)*iImax);
  /*  printf("memory allocated!\n");*/
  eMin = 0.0;
  eMax = -100000000000000000.0;
  for(iI = 0; iI < iImax; iI++){
    fscanf(fInput,"%le",&eStat[iI]);
    eStat[iI] = log(eStat[iI]);
    if(eMax < eStat[iI]){
      eMax = eStat[iI];
    }
    if(eMin > eStat[iI]){
      eMin = eStat[iI];
    }
  }
  /*  printf("read!\n");*/

  /* Reading end */

  if(iArgc >= 5){
    sscanf(cArg[4],"%ld",&iEnd);
  }
  else{
    iEnd = iImax;
  }
  if(iEnd < iBegin + 100){
    iEnd = iBegin + 100;
  }
  if(iEnd > iImax){
    iEnd = iImax;
  }

  eFontsc = 200.0;


  fclose(fInput);

  fprintf(fOutput,"%d %d\n", iI,iJ);
  fprintf(fOutput,"%%!PS-Adobe-2.0\n");
  fprintf(fOutput,"%%%%Title: proba.ps\n");
  fprintf(fOutput,"%%%%Creator: Istvan Miklos\n");
  fprintf(fOutput,"%%%%Orientation: Landscape\n");
  fprintf(fOutput,"%%%%Pages: 1\n");
  fprintf(fOutput,"%%%%BoundingBox: 0 0 612 792\n");
  fprintf(fOutput,"%%%%BeginSetup\n");
  fprintf(fOutput,"%%%%IncludeFeature: *PageSize Letter\n");
  fprintf(fOutput,"%%%%EndSetup\n");
  fprintf(fOutput,"%%%%Magnification: 1.0000\n");
  fprintf(fOutput,"%%%%EndComments\n");
  fprintf(fOutput,"/$F2psDict 200 dict def\n");
  fprintf(fOutput,"$F2psDict begin\n");
  fprintf(fOutput,"$F2psDict /mtrx matrix put\n");
  fprintf(fOutput,"/col-1 {0 setgray} bind def\n");
  fprintf(fOutput,"/col0 {0.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col1 {1.000 0.300 0.200 srgb} bind def\n");
  fprintf(fOutput,"/col2 {0.000 1.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col3 {0.000 1.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col4 {1.000 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col5 {1.000 0.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col6 {1.000 1.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col7 {1.000 1.000 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col8 {0.000 0.000 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col9 {0.000 0.000 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col10 {0.000 0.000 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col11 {0.530 0.810 1.000 srgb} bind def\n");
  fprintf(fOutput,"/col12 {0.000 0.560 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col13 {0.000 0.690 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col14 {0.000 0.820 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col15 {0.000 0.560 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col16 {0.000 0.690 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col17 {0.000 0.820 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col18 {0.560 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col19 {0.690 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col20 {0.820 0.000 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col21 {0.560 0.000 0.560 srgb} bind def\n");
  fprintf(fOutput,"/col22 {0.690 0.000 0.690 srgb} bind def\n");
  fprintf(fOutput,"/col23 {0.820 0.000 0.820 srgb} bind def\n");
  fprintf(fOutput,"/col24 {0.500 0.190 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col25 {0.630 0.250 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col26 {0.750 0.380 0.000 srgb} bind def\n");
  fprintf(fOutput,"/col27 {1.000 0.500 0.500 srgb} bind def\n");
  fprintf(fOutput,"/col28 {1.000 0.630 0.630 srgb} bind def\n");
  fprintf(fOutput,"/col29 {1.000 0.750 0.750 srgb} bind def\n");
  fprintf(fOutput,"/col30 {1.000 0.880 0.880 srgb} bind def\n");
  fprintf(fOutput,"/col31 {1.000 0.840 0.000 srgb} bind def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"end\n");
  fprintf(fOutput,"save\n");
  fprintf(fOutput,"newpath 0 792 moveto 0 0 lineto 612 0 lineto 612 792 lineto closepath clip newpath\n");
  fprintf(fOutput,"65.2 63.5 translate\n");
  fprintf(fOutput," 90 rotate\n");
  fprintf(fOutput,"1 -1 scale\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"/cp {closepath} bind def\n");
  fprintf(fOutput,"/ef {eofill} bind def\n");
  fprintf(fOutput,"/gr {grestore} bind def\n");
  fprintf(fOutput,"/gs {gsave} bind def\n");
  fprintf(fOutput,"/sa {save} bind def\n");
  fprintf(fOutput,"/rs {restore} bind def\n");
  fprintf(fOutput,"/l {lineto} bind def\n");
  fprintf(fOutput,"/m {moveto} bind def\n");
  fprintf(fOutput,"/rm {rmoveto} bind def\n");
  fprintf(fOutput,"/n {newpath} bind def\n");
  fprintf(fOutput,"/s {stroke} bind def\n");
  fprintf(fOutput,"/sh {show} bind def\n");
  fprintf(fOutput,"/slc {setlinecap} bind def\n");
  fprintf(fOutput,"/slj {setlinejoin} bind def\n");
  fprintf(fOutput,"/slw {setlinewidth} bind def\n");
  fprintf(fOutput,"/srgb {setrgbcolor} bind def\n");
  fprintf(fOutput,"/rot {rotate} bind def\n");
  fprintf(fOutput,"/sc {scale} bind def\n");
  fprintf(fOutput,"/sd {setdash} bind def\n");
  fprintf(fOutput,"/ff {findfont} bind def\n");
  fprintf(fOutput,"/sf {setfont} bind def\n");
  fprintf(fOutput,"/scf {scalefont} bind def\n");
  fprintf(fOutput,"/sw {stringwidth} bind def\n");
  fprintf(fOutput,"/tr {translate} bind def\n");
  fprintf(fOutput,"/tnt {dup dup currentrgbcolor\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add\n");
  fprintf(fOutput,"  4 -2 roll dup 1 exch sub 3 -1 roll mul add srgb}\n");
  fprintf(fOutput,"  bind def\n");
  fprintf(fOutput,"/shd {dup dup currentrgbcolor 4 -2 roll mul 4 -2 roll mul\n");
  fprintf(fOutput,"  4 -2 roll mul srgb} bind def\n");
  fprintf(fOutput,"/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n");
  fprintf(fOutput,"/$F2psEnd {$F2psEnteredState restore end} def\n");
  fprintf(fOutput,"\n");
  fprintf(fOutput,"$F2psBegin\n");
  fprintf(fOutput,"10 setmiterlimit\n");
  fprintf(fOutput," 0.06000 0.06000 sc\n");
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /* Z axis */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  700,150);
  fprintf(fOutput,"1.00 slw\n");
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  750,150,
	  650,150,
	  700,0);



  /* labeling Z axis */
  fprintf(fOutput,"17.500 slw\n");
  fprintf(fOutput,"/Times-Roman ff %f scf sf\n",eFontsc);
  
  iMin = (int)eMin;
  while(iMin % 10 != 0){
    iMin--;
  }
  if(labs(iMin) > 1000){
    while(iMin % 100 != 0){
      iMin -= 10;
    }
  }
  if(labs(iMin) > 10000){
    while(iMin % 1000 != 0){
      iMin -= 100;
    }
  }

  iMax = (int)eMax;
  while(iMax % 10 != 0){
    iMax++;
  }
  if(labs(iMax) > 1000){
    while(iMax % 100 != 0){
      iMax += 10;
    }
  }
  if(labs(iMax) > 10000){
    while(iMax % 1000 != 0){
      iMax += 100;
    }
  }

  iZstep = iMin;
  while(iZstep < iMax){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%ld) col0 sh gr\n",
	    700-(int)(sqrt(eFontsc)*sprintf(cTemp,"%ld",iMax)*10),
	    (int)(7000.0-7000.0*iMin/((double)(iMin-iMax))+iZstep*7000.0/((double)(iMin-iMax))),
	    iZstep);
    
    if(iMax - iMin > 1000){
      iZstep += 1000;
    }
    else if(iMax - iMin > 100){
      iZstep += 100;
    }
    else if(iMax - iMin > 10){
      iZstep += 10;
    }
    else{
      iZstep++;
    }
  }
  /* X axis */

  fprintf(fOutput,"n %d %d m %d %d l gs col0 s gr \n",
	  700,7000,
	  10700,7000);
  fprintf(fOutput,"n %d %d m %d %d l %d %d l \n cp gs col0 1.00 shd ef gr gs col0 s gr\n",
	  10850,7000,
	  10700,6950,
	  10700,7050);
  
  /* printf("iBegin: %d\n",iBegin);*/
  iZstep = (iEnd - iBegin)/20;
  if(iZstep <= 0){
    iZstep = 1;
  }
  for(iI = 0; iI < iEnd-iBegin; iI += iZstep){
    fprintf(fOutput,"%d %d m gs 1 -1 sc (%d) col0 sh gr\n",
	    700+(int)(iI * 10000.0/(iEnd - iBegin)), 
	    7000 + (int)(sqrt(eFontsc)*16.0),
	    (int)(iI + iBegin));
  }

  /* Data */
  /*  printf("iMin: %d, iMax: %d\n",iMin, iMax);
      printf("eMin: %e, eMax: %e\n",eMin, eMax);*/
  fprintf(fOutput,"1.000 slw\n");
  for(iI = 0; iI < iEnd - iBegin - 1; iI++){
    fprintf(fOutput,"n %d %d m %d %d l gs col1 s gr\n",   
	    700+(int)(iI * 10000.0/(iEnd - iBegin)),	    
	    (int)(7000.0-7000.0*iMin/((double)(iMin-iMax))+eStat[iI + iBegin]*7000.0/((double)(iMin-iMax))),
	    700+(int)((iI + 1) * 10000.0/(iEnd - iBegin)),
	    (int)(7000.0-7000.0*iMin/((double)(iMin-iMax))+eStat[iI + 1 + iBegin]*7000.0/((double)(iMin-iMax))));
    
  } 
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/
  /****************************************************************************************************************/

  /* at the end */
  fprintf(fOutput,"$F2psEnd\n");
  fprintf(fOutput,"rs\n");
  fprintf(fOutput,"showpage\n");

  free(eStat);

  return(0);
}
